﻿using System;
using System.Collections.Generic;
using System.ComponentModel.DataAnnotations;
using System.Linq;
using System.Threading.Tasks;
using Microsoft.AspNetCore.Authorization;
using Microsoft.AspNetCore.Http;
using Microsoft.AspNetCore.Mvc;
using Microsoft.Extensions.Caching.Memory;
using Health.Api.Infrastructure;
//using Health.Api.Infrastructure.Models;
using Health.Api.Infrastructure.Modules;

using Health.Api.Infrastructure.Queries;
using Health.Api.Infrastructure.Request;
using Health.Infra;

namespace Health.Api.Controllers
{
	[Authorize]
	[Route("api/resource")]
	[ApiController]
	public class AnalysisController : Controller
    {
		private readonly AnalysisQueries _aQueries;
		private readonly IMemoryCache _cache;
		public AnalysisController(IMemoryCache cache,AnalysisQueries aQueries)
		{
			this._cache = cache;
			this._aQueries = aQueries;
		}
		/// <summary>
		/// 医院展示
		/// </summary>
		/// <returns></returns> 
		[HttpPost("HosListInquire")]
		[AllowAnonymous]
		public (IEnumerable<dynamic>, IEnumerable<dynamic>) HosListInquire(int paseIndex, string hos_name, int hos_id)
		{
			return _aQueries.HosListInquire(paseIndex, hos_name, hos_id);
		}
		/// <summary>
		/// 数据解析
		/// </summary>
		/// <returns></returns> 
		[HttpPost("ParseInquire")]
		[AllowAnonymous]
		public void ParseInquire(string zxr, int hosid)
		{
			
			int id = _aQueries.JX_SCJXJL(hosid, zxr);//1.生成解析记录
			
			_aQueries.JX_GXID(id, hosid);//更新reg_id，master_index
			
			_aQueries.JX_DIC_DIAG(id, hosid);//更新标准库里DIC_DIAG_SUMMARY里的标准字段
			
			_aQueries.JX_DIC_FEE(id, hosid);//新建费用查询字典表
			
			_aQueries.JX_ADD_DA_Disease(id, hosid);//未匹配上的诊断导入到DA_Disease表中
			
			_aQueries.JX_DIC_DRUG_ATC(id, hosid);//匹配更新标准库 DIC_DRUG_ATC的标准字段
			
			_aQueries.JX_ADD_DA_Drug(id, hosid);//未匹配上的导入 [dbo].[DA_Drug] 做处理
			//对导入的药品跑权重
			_aQueries.JX_DRUG_DATA_QZ(id, hosid);
			//对导入的诊断做处理，剔除无效字符
			_aQueries.JX_DA_DIAGNOSIS_DATA(id, hosid);
			//新导入的诊断跑权重,生成标准科室，标准一级诊断，标准二级诊断
			_aQueries.JX_DIAGNOSIS_DATA_QZ(id, hosid);
		}

    }
}
