﻿using Health.Api.Infrastructure.Modules;
using Health.Api.Infrastructure.Queries;
using Microsoft.AspNetCore.Authorization;
using Microsoft.AspNetCore.Mvc;
using Microsoft.Data.SqlClient;
using Microsoft.Extensions.Caching.Memory;
using System.Data.Common;

namespace Health.Api.Controllers
{
    public class DrugqueryController : Controller
    {
        private readonly IMemoryCache _cache;
        private readonly ResourceQueries resourceQueries;
        private readonly DrugqueryQueries drugqueryQueries;
        public DrugqueryController(
            IMemoryCache cache,
            ResourceQueries resourceQueries,
            DrugqueryQueries drugqueryQueries)
        {
            this._cache = cache;
            this.resourceQueries = resourceQueries;
            this.drugqueryQueries = drugqueryQueries;
        }

        /// <summary>
        /// 查询病人疾病信息和药品信息//type1=疾病//type2药品
        /// </summary>
        /// <param name="sYS_Drugquery"></param>
        [HttpPost("Drugquery")]
        [AllowAnonymous]
        public void Drugquery(SYS_Drugquery sYS_Drugquery)
        { 
           
            int type = 0;
            if ((sYS_Drugquery.icd!=null || sYS_Drugquery.diseaseName!=null) && sYS_Drugquery.drugName==null && sYS_Drugquery.materialName==null)
            {
                type = 1;//1疾病 
                int num =drugqueryQueries.SqlAdd(sYS_Drugquery, type);
                drugqueryQueries.Diseasequery(type, sYS_Drugquery.type1_2, sYS_Drugquery.icd,sYS_Drugquery.diseaseName,num);
            }
            else if (sYS_Drugquery.drugName!=null && sYS_Drugquery.diseaseName == null && sYS_Drugquery.icd == null && sYS_Drugquery.materialName == null)
            {
                type = 2;//2药品 
                int num = drugqueryQueries.SqlAdd(sYS_Drugquery, type);
                drugqueryQueries.Drugquery(type, sYS_Drugquery.type1_2, sYS_Drugquery.drugName,num);
            }
            else if(sYS_Drugquery.materialName!=null && sYS_Drugquery.diseaseName==null && sYS_Drugquery.icd == null && sYS_Drugquery.drugName == null)
            {
                type = 3;//3材料
                int num = drugqueryQueries.SqlAdd(sYS_Drugquery, type);
                drugqueryQueries.Drugquery(type, sYS_Drugquery.type1_2, sYS_Drugquery.materialName,num);
            }
            else
            {
                throw new DomainException("只能单类型查询！！");
            } 
            
        }
    }
            
}
