﻿using Dapper;
using Microsoft.AspNetCore.Mvc;
using Microsoft.Data.SqlClient;
//using Health.Api.Infrastructure.Models;
using Health.Api.Infrastructure.Modules;
using Health.Api.Infrastructure.Request;
using Health.Infra;
using StackExchange.Profiling;
using StackExchange.Profiling.Data;
using System;
using System.Collections.Generic;
using System.Data.Common;
using System.Linq;
using System.Threading.Tasks;
using static UtilExtensions;

namespace Health.Api.Infrastructure.Queries
{
    public class AnalysisQueries
    {
        private readonly string _Connection156;
        private readonly string _configConnectionString;
        //private List<Common> a;
        bool state = true;
        public AnalysisQueries(string Connection156, string configConnectionString)
        {
            _Connection156 = Connection156;
            _configConnectionString = configConnectionString;
        }

        //Inquire
        /// <summary>
        ///医院展示
        /// </summary>
        public IEnumerable<dynamic> HosListInquire(string hos_name, int hos_id)
        {
            using (DbConnection connection = new SqlConnection(_Connection156))
            {
                string where = " ";
                if (!string.IsNullOrEmpty(hos_name))
                {
                    where = where + " and [HosName] like '%" + hos_name + "%'";
                }
                if (hos_id != 0)
                {
                    where = where + " and id  =" + hos_id;
                }
                var query = @" SELECT  [ID] 编号,[CODE] 编码,[HosName] 医院名称,[HosLevel] 医院等级,[HosType] 医院类型,[ExecOpenLink] 服务器,[ExecDatabase] 数据库, Replace([Province],' ','') 省份, Replace([Region],' ','') 市, Replace([City],' ','') 区 
                     FROM [DB_SV_Data_Config].[dbo].[SYS_Hospital] where id<>1 " + where;
                return connection.Query(query).ToList();
            }

        }

        public (IEnumerable<dynamic>, IEnumerable<dynamic>) HosListInquire(int paseIndex, string hos_name, int hos_id)
        {
            using (DbConnection connection = new SqlConnection(_Connection156))
            {
                string where = " ";
                if (!string.IsNullOrEmpty(hos_name))
                {
                    where = where + " and [HosName] like '%" + hos_name + "%'";
                }
                if (hos_id != 0)
                {
                    where = where + " and id  =" + hos_id;
                }
                IEnumerable<dynamic> sj = connection.Query($@"select*FROM(
                    SELECT  ROW_NUMBER() OVER(ORDER BY getdate())AS id,* FROM(
                 SELECT DISTINCT 
                       [ID] 编号,[CODE] 编码,[HosName] 医院名称,[HosLevel] 医院等级,[HosType] 医院类型,[ExecOpenLink] 服务器,[ExecDatabase] 数据库, Replace([Province],' ','') 省份,
					    Replace([Region],' ','') 市, Replace([City],' ','') 区 
                   FROM [DB_SV_Data_Config].[dbo].[SYS_Hospital] WHERE id<>1 { where}  )a )b WHERE id<={paseIndex}*10 and id>({paseIndex} - 1)*10 ").ToList();
                IEnumerable<dynamic> zon = connection.Query($@"   SELECT  CAST(COUNT(*)AS MONEY)totalCount ,{paseIndex} paseIndex FROM(
                 SELECT  DISTINCT *
                   FROM [DB_SV_Data_Config].[dbo].[SYS_Hospital] WHERE id<>1 " + where + ")a").ToList();
                return (sj, zon);
            }
            return (null, null);
        }


        private void updatezt(int id, int hos_id, string status, string log)
        {
            using (DbConnection configConnection = new SqlConnection(_configConnectionString))
            {
                configConnection.Execute(@$"update [SV_QueryPlatform].[dbo].[解析任务] set [status]='{status}',[updatedate]=getdate(),log='{log}' where hos_id={hos_id} and id={id}");
            }
        }
        //1.解析执行sql
        private void JX_zx(string sql, int hos_id, int id, SYS_Hospital hos)
        {
            DbConnection configConnection = new SqlConnection(_configConnectionString);
            服务器 fwq = configConnection.Query<服务器>($"SELECT   [服务器ip],[数据库账号],[数据库密码] FROM[SV_QueryPlatform].[dbo].[服务器] where[服务器ip] ='{hos.ExecOpenLink}'").FirstOrDefault();
            var msConnectionString = string.Format("Server={0};Database={1};User ID={2};Password={3};Trusted_Connection=False;", hos.ExecOpenLink, hos.ExecDatabase, fwq.数据库账号, fwq.数据库密码);
            // DefaultConnection
            using (DbConnection conn = new SqlConnection(msConnectionString))
            {
                try
                {
                    conn.Execute(sql, commandTimeout: 60 * 60 * 12);
                }
                catch (Exception e)
                {

                    configConnection.Execute(@$"update [SV_QueryPlatform].[dbo].[解析任务] set [status]='失败',[updatedate]=getdate() where hos_id={hos_id} and id={id}");
                }

            }
        }
        //1.解析执行sql返回数字
        private int JX_zx_int(string sql, int hos_id, int id, SYS_Hospital hos)
        {
            DbConnection configConnection = new SqlConnection(_configConnectionString);
            服务器 fwq = configConnection.Query<服务器>($"SELECT   [服务器ip],[数据库账号],[数据库密码] FROM[SV_QueryPlatform].[dbo].[服务器] where[服务器ip] ='{hos.ExecOpenLink}'").FirstOrDefault();
            var msConnectionString = string.Format("Server={0};Database={1};User ID={2};Password={3};Trusted_Connection=False;", hos.ExecOpenLink, hos.ExecDatabase, fwq.数据库账号, fwq.数据库密码);
            // DefaultConnection
            using (DbConnection conn = new SqlConnection(msConnectionString))
            {
                try
                {
                    return conn.Query<hosid>(sql).FirstOrDefault().id;
                }
                catch (Exception e)
                {

                    configConnection.Execute(@$"update [SV_QueryPlatform].[dbo].[解析任务] set [status]='失败',[updatedate]=getdate(),log=[status]+{sql} where hos_id={hos_id} and id={id}");
                }
                return 0;

            }
        }


        //生成一条解析记录
        public int JX_SCJXJL(int hos_id, string czr)
        {
            var sql = "";
            using (DbConnection configConnection = new SqlConnection(_configConnectionString)) // DefaultConnection
            {
                sql = @$" insert into [dbo].[解析任务](  [updatedate], [status], [ksdate], [hos_id], [czr])VALUES(getdate(),'开始解析',getdate(),{hos_id},'{czr}') ";
                configConnection.Execute(sql, commandTimeout: 60 * 60 * 10);
                return configConnection.Query<hosid>($@" select max(id)id from  [dbo].[解析任务]  where hos_id={hos_id} ").FirstOrDefault().id;


            }
            return 0;
        }
        //1.更新id org_code m_index
        public void JX_GXID(int id, int hos_id)
        {
            var sql = "";
            SYS_Hospital hos = new SYS_Hospital();
            using (DbConnection connection156 = new SqlConnection(_Connection156))
            {
                updatezt(id, hos_id, "处理org_code", "");
                sql = @$"  SELECT  DISTINCT ExecOpenLink , ExecDatabase FROM  [DB_SV_Data_Config].[dbo].[SYS_Hospital] A  WHERE  id ={hos_id}; ";
                hos = connection156.Query<SYS_Hospital>(sql).FirstOrDefault();
            }
            sql = @$" update [{hos.ExecDatabase}].[dbo].[ASSAY_REPORT]	 set org_code={hos_id} where org_code<>{hos_id}
                              update [{hos.ExecDatabase}].[dbo].[DIC_DEPT]		 set org_code={hos_id} where org_code<>{hos_id}
                              update [{hos.ExecDatabase}].[dbo].[DIC_DIAG]		 set org_code={hos_id} where org_code<>{hos_id}
                              update [{hos.ExecDatabase}].[dbo].[DIC_DRUG]		 set org_code={hos_id} where org_code<>{hos_id}
                              update [{hos.ExecDatabase}].[dbo].[DIC_EMP]		 set org_code={hos_id} where org_code<>{hos_id}
                              update [{hos.ExecDatabase}].[dbo].[DIC_FEE]		 set org_code={hos_id} where org_code<>{hos_id}
                              update [{hos.ExecDatabase}].[dbo].[EXEC_REPORT]	 set org_code={hos_id} where org_code<>{hos_id}
                              update [{hos.ExecDatabase}].[dbo].[INPAT_DIAG]	 set org_code={hos_id} where org_code<>{hos_id}
                              update [{hos.ExecDatabase}].[dbo].[INPAT_FEE]		 set org_code={hos_id} where org_code<>{hos_id}
                              update [{hos.ExecDatabase}].[dbo].[INPAT_ORDER]	 set org_code={hos_id} where org_code<>{hos_id}
                              update [{hos.ExecDatabase}].[dbo].[INPAT_REG_INFO] set org_code={hos_id} where org_code<>{hos_id}
                              update [{hos.ExecDatabase}].[dbo].[OUT_DIAG]		 set org_code={hos_id} where org_code<>{hos_id}
                              update [{hos.ExecDatabase}].[dbo].[OUT_FEE]		 set org_code={hos_id} where org_code<>{hos_id}
                              update [{hos.ExecDatabase}].[dbo].[OUT_PRES]		 set org_code={hos_id} where org_code<>{hos_id}
                              update [{hos.ExecDatabase}].[dbo].[OUT_REG_INFO]	 set org_code={hos_id} where org_code<>{hos_id}";
            updatezt(id, hos_id, "处理org_code", sql);
            JX_zx(sql, hos_id, id, hos);
            sql = $@"
                              SELECT (
                                         SELECT COUNT(1) FROM [{hos.ExecDatabase}].[dbo].[OUT_REG_INFO] A   JOIN  [{hos.ExecDatabase}].[dbo].[PUB_PATIENT]  b    ON A.PERSON_CODE=b.PERSON_CODE  WHERE A.PERSON_ID!=b.PERSON_ID OR A.PERSON_ID IS NULL
                                      )+(SELECT COUNT(1) FROM [{hos.ExecDatabase}].[dbo].[OUT_DIAG] A       JOIN  [{hos.ExecDatabase}].[dbo].OUT_REG_INFO   b    ON A.REG_CODE=b.REG_CODE WHERE A.REG_ID!=b.REG_ID OR A.REG_ID IS NULL
                                      )+(SELECT COUNT(1) FROM [{hos.ExecDatabase}].[dbo].[OUT_FEE]A         JOIN  [{hos.ExecDatabase}].[dbo].OUT_REG_INFO  b    ON A.REG_CODE=b.REG_CODE  WHERE A.REG_ID!=b.REG_ID OR A.REG_ID IS NULL
                                      )+(SELECT COUNT(1) FROM [{hos.ExecDatabase}].[dbo].[OUT_PRES]A        JOIN  [{hos.ExecDatabase}].[dbo].OUT_REG_INFO  b    ON A.REG_code=b.reg_code  WHERE A.REG_ID!=b.REG_ID OR A.REG_ID IS NULL
                                      )+(SELECT COUNT(1) FROM [{hos.ExecDatabase}].[dbo].[inpat_REG_INFO] A JOIN  [{hos.ExecDatabase}].[dbo].[PUB_PATIENT] b    ON b.PERSON_CODE=a.PERSON_CODE  WHERE A.PERSON_ID!=b.PERSON_ID OR A.PERSON_ID IS NULL
                                      )+(SELECT COUNT(1) FROM [{hos.ExecDatabase}].[dbo].[inpat_diag] A     JOIN  [{hos.ExecDatabase}].[dbo].[inpat_reg_info] b ON b.REG_CODE=a.REG_CODE  WHERE A.REG_ID!=b.REG_ID OR A.REG_ID IS NULL
                                      )+(SELECT COUNT(1) FROM [{hos.ExecDatabase}].[dbo].[inpat_order] A    JOIN  [{hos.ExecDatabase}].[dbo].[inpat_reg_info] b ON b.REG_CODE=a.REG_CODE  WHERE A.REG_ID!=b.REG_ID OR A.REG_ID IS NULL
                                      )+(SELECT COUNT(1) FROM [{hos.ExecDatabase}].[dbo].[inpat_fee] A      JOIN  [{hos.ExecDatabase}].[dbo].[inpat_reg_info] b ON b.REG_CODE=a.REG_CODE  WHERE A.REG_ID!=b.REG_ID OR A.REG_ID IS NULL
                                      )+(SELECT COUNT(1) FROM [{hos.ExecDatabase}].[dbo].[ops_info] A       JOIN  [{hos.ExecDatabase}].[dbo].[inpat_reg_info] b ON b.REG_CODE=a.REG_CODE  WHERE A.REG_ID!=b.REG_ID OR A.REG_ID IS NULL
                                      )+(SELECT COUNT(1) FROM [{hos.ExecDatabase}].[dbo].EXEC_REPORT A      JOIN  [{hos.ExecDatabase}].[dbo].OUT_REG_INFO B     ON a.REG_CODE=B.REG_CODE and REG_Source=1  WHERE A.REG_ID!=b.REG_ID OR A.REG_ID IS NULL
                                      )+(SELECT COUNT(1) FROM [{hos.ExecDatabase}].[dbo].[EXEC_REPORT] A    JOIN  [{hos.ExecDatabase}].[dbo].INPAT_REG_INFO B   ON a.REG_CODE=B.REG_CODE and REG_Source=2  WHERE A.REG_ID!=b.REG_ID OR A.REG_ID IS NULL
                                      )+(SELECT COUNT(1) FROM [{hos.ExecDatabase}].[dbo].[ASSAY_REPORT] A   JOIN  [{hos.ExecDatabase}].[dbo].[OUT_REG_INFO] B   ON a.REG_CODE=B.REG_CODE and REG_Source=1  WHERE A.REG_ID!=b.REG_ID OR A.REG_ID IS NULL
                                      )+(SELECT COUNT(1) FROM [{hos.ExecDatabase}].[dbo].[ASSAY_REPORT] A   JOIN  [{hos.ExecDatabase}].[dbo].[INPAT_REG_INFO] B ON a.REG_CODE=B.REG_CODE and REG_Source=2  WHERE A.REG_ID!=b.REG_ID OR A.REG_ID IS NULL
                                      )+(SELECT COUNT(1) FROM [{hos.ExecDatabase}].[dbo].[NIS_RECORD] A     JOIN  [{hos.ExecDatabase}].[dbo].[OUT_REG_INFO] B   ON a.REG_CODE=B.REG_CODE and REG_Source=1  WHERE A.REG_ID!=b.REG_ID OR A.REG_ID IS NULL
                                      )+(SELECT COUNT(1) FROM [{hos.ExecDatabase}].[dbo].[NIS_RECORD] A     JOIN  [{hos.ExecDatabase}].[dbo].[INPAT_REG_INFO] B ON a.REG_CODE=B.REG_CODE and REG_Source=2  WHERE A.REG_ID!=b.REG_ID OR A.REG_ID IS NULL
                              )id";
            updatezt(id, hos_id, "检查id是否更新", sql);
            //判断id是否修
            //判断MASTER_INDEX是否修改
            sql = $@"SELECT COUNT(1)id FROM [{hos.ExecDatabase}].[dbo].PUB_PATIENT
                               where MASTER_INDEX is null";
            updatezt(id, hos_id, "更新MASTER_INDEX", "判断MASTER_INDEX是否修改" + sql.Replace("'", "''"));
            if (JX_zx_int(sql, hos_id, id, hos) > 0 && hos.ExecDatabase.Length == 13)
            {
                sql = $@" IF EXISTS(SELECT * FROM [{hos.ExecDatabase}].dbo.SYSOBJECTS WHERE NAME = 'PATIENT')
				DROP TABLE [{hos.ExecDatabase}].dbo.PATIENT
				IF EXISTS(SELECT * FROM [{hos.ExecDatabase}].dbo.SYSOBJECTS WHERE NAME = 'PATIENT_NOTNULL')
				DROP TABLE [{hos.ExecDatabase}].dbo.PATIENT_NOTNULL
				IF EXISTS(SELECT * FROM [{hos.ExecDatabase}].dbo.SYSOBJECTS WHERE NAME = 'PATIENT_STORE1')
				DROP TABLE [{hos.ExecDatabase}].dbo.PATIENT_STORE1
				IF EXISTS(SELECT * FROM [{hos.ExecDatabase}].dbo.SYSOBJECTS WHERE NAME = 'PATIENT_STORE2')
				DROP TABLE [{hos.ExecDatabase}].dbo.PATIENT_STORE2
				CREATE TABLE [{hos.ExecDatabase}].dbo.PATIENT (PERSON_ID INT,ID_CARD NVARCHAR(max),CARD_ID NVARCHAR(max),NEWPERSON_ID INT)
				CREATE TABLE [{hos.ExecDatabase}].dbo.PATIENT_NOTNULL(PERSON_ID INT,CODE NVARCHAR(50),NEWPERSON_ID INT)
				CREATE TABLE [{hos.ExecDatabase}].dbo.PATIENT_STORE1(PERSON_ID INT,CODE NVARCHAR(50),NEWPERSON_ID INT)
				CREATE TABLE [{hos.ExecDatabase}].dbo.PATIENT_STORE2(PERSON_ID INT,CODE NVARCHAR(50),NEWPERSON_ID INT)
				CREATE NONCLUSTERED INDEX [INDEX_PATIENT] ON [{hos.ExecDatabase}].[dbo].[PATIENT]
				([ID_CARD] ASC, [CARD_ID] ASC
				)WITH (PAD_INDEX = OFF, STATISTICS_NORECOMPUTE = OFF, SORT_IN_TEMPDB = OFF, DROP_EXISTING = OFF, ONLINE = OFF, ALLOW_ROW_LOCKS = ON, ALLOW_PAGE_LOCKS = ON)
				CREATE NONCLUSTERED INDEX [INDEX_PATIENT_NOTNULL] ON  [{hos.ExecDatabase}].[dbo].[PATIENT_NOTNULL] ([CODE] ASC )WITH (PAD_INDEX = OFF, STATISTICS_NORECOMPUTE = OFF, SORT_IN_TEMPDB = OFF, DROP_EXISTING = OFF, ONLINE = OFF, ALLOW_ROW_LOCKS = ON, ALLOW_PAGE_LOCKS = ON)
				CREATE NONCLUSTERED INDEX [INDEX_PATIENT_STORE1] ON  [{hos.ExecDatabase}].[dbo].[PATIENT_STORE1] ([CODE] ASC )WITH (PAD_INDEX = OFF, STATISTICS_NORECOMPUTE = OFF, SORT_IN_TEMPDB = OFF, DROP_EXISTING = OFF, ONLINE = OFF, ALLOW_ROW_LOCKS = ON, ALLOW_PAGE_LOCKS = ON)
				CREATE NONCLUSTERED INDEX [INDEX_PATIENT_STORE2] ON  [{hos.ExecDatabase}].[dbo].[PATIENT_STORE2] ([CODE] ASC )WITH (PAD_INDEX = OFF, STATISTICS_NORECOMPUTE = OFF, SORT_IN_TEMPDB = OFF, DROP_EXISTING = OFF, ONLINE = OFF, ALLOW_ROW_LOCKS = ON, ALLOW_PAGE_LOCKS = ON)
				CREATE NONCLUSTERED INDEX [INDEX1_PATIENT_NOTNULL] ON  [{hos.ExecDatabase}].[dbo].[PATIENT_NOTNULL]([PERSON_ID] ASC, [CODE] ASC, [NEWPERSON_ID] ASC )WITH (PAD_INDEX = OFF, STATISTICS_NORECOMPUTE = OFF, SORT_IN_TEMPDB = OFF, DROP_EXISTING = OFF, ONLINE = OFF, ALLOW_ROW_LOCKS = ON, ALLOW_PAGE_LOCKS = ON)
				CREATE NONCLUSTERED INDEX [INDEX1_PATIENT_STORE1] ON  [{hos.ExecDatabase}].[dbo].[PATIENT_STORE1] ([PERSON_ID] ASC, [CODE] ASC, [NEWPERSON_ID] ASC )WITH (PAD_INDEX = OFF, STATISTICS_NORECOMPUTE = OFF, SORT_IN_TEMPDB = OFF, DROP_EXISTING = OFF, ONLINE = OFF, ALLOW_ROW_LOCKS = ON, ALLOW_PAGE_LOCKS = ON)
				CREATE NONCLUSTERED INDEX [INDEX1_PATIENT_STORE2] ON  [{hos.ExecDatabase}].[dbo].[PATIENT_STORE2] ([PERSON_ID] ASC, [CODE] ASC, [NEWPERSON_ID] ASC )WITH (PAD_INDEX = OFF, STATISTICS_NORECOMPUTE = OFF, SORT_IN_TEMPDB = OFF, DROP_EXISTING = OFF, ONLINE = OFF, ALLOW_ROW_LOCKS = ON, ALLOW_PAGE_LOCKS = ON)
				CREATE NONCLUSTERED INDEX [INDEX2_PATIENT] ON  [{hos.ExecDatabase}].[dbo].[PATIENT] ([PERSON_ID] ASC )WITH (PAD_INDEX = OFF, STATISTICS_NORECOMPUTE = OFF, SORT_IN_TEMPDB = OFF, DROP_EXISTING = OFF, ONLINE = OFF, ALLOW_ROW_LOCKS = ON, ALLOW_PAGE_LOCKS = ON)
				CREATE NONCLUSTERED INDEX [INDEX2_PATIENT_NOTNULL] ON  [{hos.ExecDatabase}].[dbo].[PATIENT_NOTNULL] ([PERSON_ID] ASC )WITH (PAD_INDEX = OFF, STATISTICS_NORECOMPUTE = OFF, SORT_IN_TEMPDB = OFF, DROP_EXISTING = OFF, ONLINE = OFF, ALLOW_ROW_LOCKS = ON, ALLOW_PAGE_LOCKS = ON)
				CREATE NONCLUSTERED INDEX [INDEX2_PATIENT_STORE1] ON  [{hos.ExecDatabase}].[dbo].[PATIENT_STORE1] ([PERSON_ID] ASC )WITH (PAD_INDEX = OFF, STATISTICS_NORECOMPUTE = OFF, SORT_IN_TEMPDB = OFF, DROP_EXISTING = OFF, ONLINE = OFF, ALLOW_ROW_LOCKS = ON, ALLOW_PAGE_LOCKS = ON)
				CREATE NONCLUSTERED INDEX [INDEX2_PATIENT_STORE2] ON  [{hos.ExecDatabase}].[dbo].[PATIENT_STORE2] ([PERSON_ID] ASC )WITH (PAD_INDEX = OFF, STATISTICS_NORECOMPUTE = OFF, SORT_IN_TEMPDB = OFF, DROP_EXISTING = OFF, ONLINE = OFF, ALLOW_ROW_LOCKS = ON, ALLOW_PAGE_LOCKS = ON)";
                updatezt(id, hos_id, "更新MASTER_INDEX", "创建需要使用的表" + sql.Replace("'", "''"));
                JX_zx(sql, hos_id, id, hos);


                //判断病人表中主索引列是否有值

                sql = @$" SELECT  CASE WHEN MAX(MASTER_INDEX) IS NULL THEN 0 ELSE MAX(MASTER_INDEX) END id  FROM [{hos.ExecDatabase}].[DBO].PUB_PATIENT where MASTER_INDEX is not null; ";
                updatezt(id, hos_id, "更新MASTER_INDEX", "判断病人表中主索引列是否有值" + sql.Replace("'", "''"));
                int COUNT = JX_zx_int(sql, hos_id, id, hos);

                sql = @$" SELECT  COUNT(1) id  FROM  [{hos.ExecDatabase}].[DBO].PUB_PATIENT where MASTER_INDEX is  null ";
                int COUNT_ROW = JX_zx_int(sql, hos_id, id, hos);
                if (COUNT_ROW != 0)
                {
                    //将病人的医保号和身份证号集中放在一张表中
                    sql = $@"truncate TABLE [{hos.ExecDatabase}].[DBO].PATIENT
                                 truncate TABLE [{hos.ExecDatabase}].[DBO].PATIENT_NOTNULL
                                 truncate TABLE [{hos.ExecDatabase}].[DBO].PATIENT_STORE1
                                 truncate TABLE [{hos.ExecDatabase}].[DBO].PATIENT_STORE2
                        insert into [{hos.ExecDatabase}].[DBO].PATIENT(PERSON_ID,ID_CARD,CARD_ID,NEWPERSON_ID)
                        SELECT  TAB.PERSON_ID, CAST(ID_CARD AS NVARCHAR(100))ID_CARD, CARD_ID ,NULL NEWPERSON_ID FROM  
                        (SELECT PERSON_ID,ID_CARD FROM [{hos.ExecDatabase}].[DBO].PUB_PATIENT  WHERE [MASTER_INDEX] IS NULL ) TAB 
                        LEFT JOIN (SELECT PERSON_ID, CARD_ID FROM (SELECT DJ.PERSON_ID, CARD_ID FROM [{hos.ExecDatabase}].[DBO].[OUT_REG_INFO] DJ GROUP BY DJ.PERSON_ID, CARD_ID 
                        UNION 
                        SELECT DJ.PERSON_ID, CARD_ID FROM [{hos.ExecDatabase}].[DBO].[INPAT_REG_INFO] DJ GROUP BY DJ.PERSON_ID,CARD_ID) TA ) TAB1 
                        ON TAB.PERSON_ID=TAB1.PERSON_ID GROUP BY TAB.PERSON_ID,ID_CARD,CARD_ID;";
                    updatezt(id, hos_id, "更新MASTER_INDEX", "将病人的医保号和身份证号集中放在一张表中" + sql.Replace("'", "''"));
                    JX_zx(sql, hos_id, id, hos);
                    //获取最大的master_index的值

                    sql = @$" select case when max(NEWPERSON_ID) is null then 0 else max(NEWPERSON_ID) end id from [{hos.ExecDatabase}].[dbo].[PATIENT]";
                    updatezt(id, hos_id, "更新MASTER_INDEX", "获取最大的master_index的值" + sql.Replace("'", "''"));
                    int mark = JX_zx_int(sql, hos_id, id, hos);

                    //置空不符合规范的身份证号和医保号
                    //更新无医保号且无身份证号的病人
                    sql = $@"IF EXISTS(SELECT * FROM [{hos.ExecDatabase}].dbo.SYSOBJECTS WHERE NAME = 'tablea')
				                   DROP TABLE [{hos.ExecDatabase}].dbo.tablea
                                 UPDATE [{hos.ExecDatabase}].[dbo].PATIENT SET ID_CARD = NULL WHERE ID_CARD NOT LIKE '[0-9]%' OR LEN(ID_CARD)<=15  OR ID_CARD  LIKE '%8888%' OR ID_CARD  LIKE '%0000%'
		                         UPDATE [{hos.ExecDatabase}].[dbo].PATIENT SET CARD_ID = NULL WHERE CARD_ID NOT LIKE '[0-9]%' OR LEN(CARD_ID)<6
		                         create table [{hos.ExecDatabase}].[dbo].tablea  (id int primary key identity({COUNT + mark + 1},1),[code] nvarchar(200))
		                         insert into [{hos.ExecDatabase}].[dbo].tablea(code)
		                         select distinct person_id from  [{hos.ExecDatabase}].[dbo].[PATIENT] WHERE ID_CARD IS NULL AND  CARD_ID IS NULL
		                         update [{hos.ExecDatabase}].[dbo].[PATIENT] set NEWPERSON_ID = b.id from [{hos.ExecDatabase}].[dbo].tablea b where [{hos.ExecDatabase}].[dbo].[PATIENT].PERSON_ID = b.code 
		                         insert into [{hos.ExecDatabase}].[dbo].PATIENT_NOTNULL(PERSON_ID,CODE,NEWPERSON_ID)
		                         select PERSON_ID,ID_CARD CODE, NEWPERSON_ID from [{hos.ExecDatabase}].[dbo].PATIENT WHERE NEWPERSON_ID IS NULL
		                         UNION ALL
		                         select PERSON_ID,CARD_ID CODE, NEWPERSON_ID from [{hos.ExecDatabase}].[dbo].PATIENT WHERE NEWPERSON_ID IS NULL
                                 drop table [{hos.ExecDatabase}].[dbo].tablea";
                    updatezt(id, hos_id, "更新MASTER_INDEX", "置空不符合规范的身份证号和医保号&&更新无医保号且无身份证号的病人" + sql.Replace("'", "''"));
                    JX_zx(sql, hos_id, id, hos);

                    //递归更新身份证或者医保号相同的主索引
                    sql = $@"IF EXISTS(SELECT * FROM [{hos.ExecDatabase}].dbo.SYSOBJECTS WHERE NAME = 'table2')
				          DROP TABLE [{hos.ExecDatabase}].dbo.table2
                          create table  [{hos.ExecDatabase}].[DBO].table2  (id int primary key identity({mark + 1},1),[code] nvarchar(200))
		                  insert into [{hos.ExecDatabase}].[DBO].PATIENT_STORE1(PERSON_ID,CODE,NEWPERSON_ID)select PERSON_ID,CODE, NEWPERSON_ID from [{hos.ExecDatabase}].[DBO].PATIENT_NOTNULL 
                          DECLARE @COUNT INT WHILE 1=1
			              BEGIN
			              truncate table [{hos.ExecDatabase}].[DBO].PATIENT_STORE2
			              insert into [{hos.ExecDatabase}].[DBO].PATIENT_STORE2  (PERSON_ID,CODE,NEWPERSON_ID) select A.PERSON_ID,B.CODE,B.PERSON_ID NEWPERSON_ID from [{hos.ExecDatabase}].[DBO].PATIENT_STORE1 A JOIN  [{hos.ExecDatabase}].[DBO].PATIENT_NOTNULL B ON A.CODE = B.CODE  GROUP BY A.PERSON_ID,B.PERSON_ID,b.CODE 
			              insert into [{hos.ExecDatabase}].[DBO].PATIENT_STORE2  (PERSON_ID,CODE,NEWPERSON_ID) select A.PERSON_ID,B.CODE,B.PERSON_ID NEWPERSON_ID from [{hos.ExecDatabase}].[DBO].PATIENT_STORE2 A JOIN [{hos.ExecDatabase}].[DBO].PATIENT_STORE2 B ON A.NEWPERSON_ID = B.PERSON_ID  GROUP BY A.PERSON_ID,B.PERSON_ID,b.CODE 
                          SELECT @COUNT=COUNT(1)  FROM   [{hos.ExecDatabase}].[DBO].PATIENT_STORE2  A LEFT JOIN   [{hos.ExecDatabase}].[DBO].PATIENT_STORE1  B ON A.PERSON_ID = B.PERSON_ID and A.NEWPERSON_ID = B.NEWPERSON_ID AND A.CODE = B.CODE WHERE B.PERSON_ID IS NULL 
			              IF @COUNT=0 BREAK
			              truncate table [{hos.ExecDatabase}].[DBO].PATIENT_STORE1
			              INSERT INTO [{hos.ExecDatabase}].[DBO].PATIENT_STORE1 (PERSON_ID,CODE,NEWPERSON_ID) SELECT PERSON_ID,CODE,NEWPERSON_ID FROM [{hos.ExecDatabase}].[DBO].PATIENT_STORE2 GROUP BY PERSON_ID,CODE,NEWPERSON_ID 
                          END  
			              insert into [{hos.ExecDatabase}].[DBO].table2(code) SELECT DISTINCT A.NEWPERSON_ID FROM [{hos.ExecDatabase}].[DBO].PATIENT_STORE2 A ORDER BY NEWPERSON_ID
			              UPDATE [{hos.ExecDatabase}].[DBO].PATIENT_STORE2 SET  NEWPERSON_ID = b.id from [{hos.ExecDatabase}].[DBO].table2 b where [{hos.ExecDatabase}].[DBO].[PATIENT_STORE2].NEWPERSON_ID = b.code  
			              update [{hos.ExecDatabase}].[DBO].[PATIENT] set NEWPERSON_ID = b.NEWPERSON_ID from  (SELECT PERSON_ID,MIN(NEWPERSON_ID) NEWPERSON_ID FROM [{hos.ExecDatabase}].[DBO].PATIENT_STORE2 GROUP BY PERSON_ID) b where [{hos.ExecDatabase}].[DBO].[PATIENT].PERSON_ID = b.PERSON_ID 
			                         drop table [{hos.ExecDatabase}].dbo.table2";
                    updatezt(id, hos_id, "更新MASTER_INDEX", "递归更新身份证或者医保号相同的主索引" + sql.Replace("'", "''"));
                    JX_zx(sql, hos_id, id, hos);


                    sql = $@"UPDATE [{hos.ExecDatabase}].dbo.PATIENT SET NEWPERSON_ID = B.MASTER_INDEX FROM (SELECT A.NEWPERSON_ID,B.MASTER_INDEX FROM [{hos.ExecDatabase}].dbo.PATIENT A  JOIN [{hos.ExecDatabase}].dbo.PUB_PATIENT B ON A.ID_CARD = B.ID_CARD WHERE B.MASTER_INDEX IS NOT NULL AND B.ID_CARD LIKE '[0-9]%' AND  LEN(B.ID_CARD)>=15  AND B.ID_CARD NOT LIKE '%8888%' AND B.ID_CARD NOT LIKE '%0000%' GROUP BY A.NEWPERSON_ID,B.MASTER_INDEX) B  WHERE PATIENT.NEWPERSON_ID = B.NEWPERSON_ID
                         UPDATE [{hos.ExecDatabase}].dbo.PATIENT SET NEWPERSON_ID = B.MASTER_INDEX FROM (SELECT A.NEWPERSON_ID,B.MASTER_INDEX FROM [{hos.ExecDatabase}].dbo.PATIENT A  JOIN  ( SELECT B.CARD_ID,MASTER_INDEX FROM [{hos.ExecDatabase}].dbo.[PUB_PATIENT] A LEFT JOIN [{hos.ExecDatabase}].dbo.OUT_REG_INFO B ON A.PERSON_CODE  = B.PERSON_CODE WHERE A.MASTER_INDEX IS NOT NULL  AND A.ID_CARD LIKE '[0-9]%' AND  LEN(A.ID_CARD)>=15  AND A.ID_CARD NOT LIKE '%8888%' AND A.ID_CARD NOT LIKE '%0000%' AND B.CARD_ID  LIKE '[0-9]%' AND  LEN(B.CARD_ID)>=6 AND B.CARD_ID IS NOT NULL UNION SELECT B.CARD_ID,MASTER_INDEX  FROM [{hos.ExecDatabase}].dbo.[PUB_PATIENT] A LEFT JOIN [{hos.ExecDatabase}].dbo.INPAT_REG_INFO B ON A.PERSON_CODE  = B.PERSON_CODE WHERE A.MASTER_INDEX IS NOT NULL AND A.ID_CARD LIKE '[0-9]%' AND  LEN(A.ID_CARD)>=15  AND A.ID_CARD NOT LIKE '%8888%' AND A.ID_CARD NOT LIKE '%0000%' AND B.CARD_ID  LIKE '[0-9]%' AND  LEN(B.CARD_ID)>=6 AND B.CARD_ID IS NOT NULL ) B ON A.CARD_ID = B.CARD_ID GROUP BY A.NEWPERSON_ID,B.MASTER_INDEX ) B  WHERE PATIENT.NEWPERSON_ID = B.NEWPERSON_ID";
                    updatezt(id, hos_id, "更新MASTER_INDEX", "同步ID_CARD或医保号相同的病人主索引.." + sql.Replace("'", "''"));
                    JX_zx(sql, hos_id, id, hos);

                    sql = $@"UPDATE [{hos.ExecDatabase}].dbo.PUB_PATIENT SET MASTER_INDEX=NEWPERSON_ID FROM (SELECT [PERSON_ID],NEWPERSON_ID FROM [{hos.ExecDatabase}].dbo.PATIENT GROUP BY [PERSON_ID], NEWPERSON_ID) TAB,[{hos.ExecDatabase}].dbo.PUB_PATIENT B WHERE B.PERSON_ID=TAB.PERSON_ID;
                                 ";
                    updatezt(id, hos_id, "更新MASTER_INDEX", "将数据更新回病人登记表.." + sql.Replace("'", "''"));
                    JX_zx(sql, hos_id, id, hos);
                    sql = $@"DROP TABLE[{ hos.ExecDatabase}].dbo.PATIENT
                         DROP TABLE[{ hos.ExecDatabase}].dbo.PATIENT_NOTNULL
                         DROP TABLE[{ hos.ExecDatabase}].dbo.PATIENT_STORE1
                         DROP TABLE[{ hos.ExecDatabase}].dbo.PATIENT_STORE2";
                    updatezt(id, hos_id, "更新MASTER_INDEX", "删除临时表.." + sql.Replace("'", "''"));
                    JX_zx(sql, hos_id, id, hos);
                }
            }
        }

        public void JX_DIC_DIAG(int id, int hos_id)
        {
            var sql = "";
            SYS_Hospital hos = new SYS_Hospital();
            using (DbConnection connection156 = new SqlConnection(_Connection156))
            {
                sql = @$"  SELECT  DISTINCT ExecOpenLink , ExecDatabase FROM  [DB_SV_Data_Config].[dbo].[SYS_Hospital] A  WHERE  id ={hos_id}; ";
                hos = connection156.Query<SYS_Hospital>(sql).FirstOrDefault();
            }
            sql = @$" IF EXISTS(SELECT * FROM [{hos.ExecDatabase}].dbo.SYSOBJECTS WHERE NAME = 'DIC_DIAG_SUMMARY')
			drop table [{hos.ExecDatabase}].[dbo].[DIC_DIAG_SUMMARY];
			CREATE TABLE [{hos.ExecDatabase}].[dbo].[DIC_DIAG_SUMMARY](
		    [ID] [int] IDENTITY(1,1) NOT NULL,
		    [DISEASE_NAME] [nvarchar](500) NULL,
		    [ICD]  [nvarchar](50) NULL,
		    [ICD_CODE]  [nvarchar](50) NULL,
		    [I_DEPT_NAME] [nvarchar](100) NULL,
		    [F_DIAG] [nvarchar](200) NULL,
		    [S_DIAG] [nvarchar](200) NULL
		    );
            IF EXISTS(SELECT * FROM [{hos.ExecDatabase}].dbo.SYSOBJECTS WHERE NAME = 'DIC_DIAG_GATHER')
			drop table [{hos.ExecDatabase}].[dbo].[DIC_DIAG_GATHER];
             CREATE TABLE [dbo].[DIC_DIAG_GATHER](
	         [ID] [int] IDENTITY(1,1) NOT NULL,
		     [DISEASE_NAME] [nvarchar](500) NULL,
		     [ICD_ID]  INT NULL,
		     [I_ICD_CODE]  [nvarchar](50) NULL,
		     [I_DEPT_NAME] [nvarchar](100) NULL,
		     [DIAGNOSIS] [nvarchar](200) NULL,
		     [DISEASE] [nvarchar](200) NULL
	          );
		    INSERT INTO [{hos.ExecDatabase}].[dbo].[DIC_DIAG_SUMMARY]([DISEASE_NAME],[ICD])select   disease_name,max(icd) from [{hos.ExecDatabase}].[dbo].[OUT_DIAG]where disease_name IS NOT NULL AND disease_name !='' group by disease_name union select   disease_name,max(icd) from [{hos.ExecDatabase}].[dbo].[INPAT_DIAG]where disease_name IS NOT NULL AND disease_name !='' group by disease_name";
            updatezt(id, hos_id, "创建诊断项目汇总表", sql.Replace("'", "''"));
            JX_zx(sql, hos_id, id, hos);

            //复制DA_Disease这张表
            var fwq = "";
            if (hos.ExecOpenLink != "192.168.18.156")
            {
                fwq = "[192.168.18.156].";
            }
            sql = @$"SELECT * into [{hos.ExecDatabase}].dbo.DA_Disease FROM {fwq}[SV_DATA_CONFIG].[dbo].[DA_Disease];
                         SELECT * into [{hos.ExecDatabase}].dbo.DA_DISEASE_ICD FROM {fwq}[SV_DATA_CONFIG].[dbo].[DA_DISEASE_ICD];
                         SELECT * into [{hos.ExecDatabase}].dbo.DIC_ICD FROM {fwq}[SV_DATA_CONFIG].[dbo].[DIC_ICD];";
            updatezt(id, hos_id, "复制DA_Disease这张表", sql.Replace("'", "''"));
            JX_zx(sql, hos_id, id, hos);

            //匹配诊断
            sql = @$"UPDATE [{hos.ExecDatabase}].[dbo].[DIC_DIAG_SUMMARY]
                     SET ICD_CODE = d.I_ICD,[F_DIAG] = d.I_CLASS_DISEASE,
                     [S_DIAG] = d.I_DISEASE, [I_DEPT_NAME] = d.I_DEPARTMENT  FROM [{hos.ExecDatabase}].[dbo].[DIC_DIAG_SUMMARY] t,
                     [{hos.ExecDatabase}].[dbo].[DA_Disease] d WHERE  t.DISEASE_NAME = d.[HOSPITAL_DISEASE] and(isnull(d.HOSPITAL_DISEASE, '') <> '');
                      insert into  [{hos.ExecDatabase}].[dbo].[DIC_DIAG_GATHER](DISEASE_NAME,ICD_ID, I_ICD_CODE,I_DEPT_NAME,DIAGNOSIS,DISEASE)
	                  select [DISEASE_NAME],d.id ICD_ID,d.icd I_ICD_CODE,[DEPARTMENT] I_DEPT_NAME,[DIAGNOSIS],[DISEASE]  from 
                      (select distinct [DISEASE_NAME] from   [{hos.ExecDatabase}].[dbo].[DIC_DIAG_SUMMARY] ) a 
                      left join [{hos.ExecDatabase}].[dbo].[DA_Disease]  b on a.DISEASE_NAME=b.[HOSPITAL_DISEASE] 
                      left join [{hos.ExecDatabase}].[dbo].[DA_DISEASE_ICD]   c on b.id=c.DISEASE_ID
                      left join [{hos.ExecDatabase}].[dbo].[DIC_ICD] d on c.ICD_ID=d.ID
                      DROP TABLE [{hos.ExecDatabase}].[dbo].DA_Disease;  
                      DROP TABLE [{hos.ExecDatabase}].[dbo].DA_DISEASE_ICD;
                      DROP TABLE[{hos.ExecDatabase}].[dbo]. DIC_ICD
                   ";
            updatezt(id, hos_id, "更新DIC_DIAG_GATHER", sql.Replace("'", "''"));
            JX_zx(sql, hos_id, id, hos);

            //
        }

        public void JX_DIC_FEE(int id, int hos_id)
        {
            var sql = "";
            SYS_Hospital hos = new SYS_Hospital();
            using (DbConnection connection156 = new SqlConnection(_Connection156))
            {
                sql = @$"  SELECT  DISTINCT ExecOpenLink , ExecDatabase FROM  [DB_SV_Data_Config].[dbo].[SYS_Hospital] A  WHERE  id ={hos_id}; ";
                hos = connection156.Query<SYS_Hospital>(sql).FirstOrDefault();
            }
            sql = @$" IF EXISTS(SELECT * FROM [{hos.ExecDatabase}].dbo.SYSOBJECTS WHERE NAME = 'DIC_FEE_SUMMARY')
			drop table [{hos.ExecDatabase}].[dbo].[DIC_FEE_SUMMARY];

			CREATE TABLE [{hos.ExecDatabase}].[dbo].[DIC_FEE_SUMMARY](
	           [ID] [int] IDENTITY(1,1) NOT NULL,
	           [ITEM_NAME] [nvarchar](200) NULL,
	           [CATEGORY]  [nvarchar](200) NULL,
	           [I_TYPE_NAME] [nvarchar](200) NULL,
	           [MEDIC_AREA] [nvarchar](200) NULL
	           );
            ";
            updatezt(id, hos_id, "DIC_FEE_SUMMARY表的生成", sql.Replace("'", "''"));
            JX_zx(sql, hos_id, id, hos);
            var fwq = "";
            if (hos.ExecOpenLink != "192.168.18.156")
            {
                fwq = "[192.168.18.156].";
            }
            //复制DA_Disease这张表 
            sql = @$" INSERT INTO [dbo].[DIC_FEE_SUMMARY]([ITEM_NAME],MEDIC_AREA,CATEGORY,I_TYPE_NAME)
       SELECT t2.item_name,t2.medic_area,t2.category,t1.insurance_category FROM {fwq}[DB_SV_Data_Config].dbo.DA_Hos_Category t1 RIGHT JOIN (
            SELECT category,item_name,medic_area FROM    [dbo].[OUT_FEE]  WHERE ITEM_NAME IS NOT NULL AND ITEM_NAME !='' GROUP  BY category,item_name,medic_area
                   UNION
            SELECT category,item_name,medic_area FROM [dbo].INPAT_FEE WHERE ITEM_NAME IS NOT NULL AND ITEM_NAME !='' GROUP  BY category,item_name,medic_area) t2 
         ON t1.category = t2.category";

            updatezt(id, hos_id, "从费用中取出不重复的费用", sql.Replace("'", "''"));
            JX_zx(sql, hos_id, id, hos);

        }

        public void JX_ADD_DA_Disease(int id, int hos_id)
        {
            var sql = "";
            SYS_Hospital hos = new SYS_Hospital();
            using (DbConnection connection156 = new SqlConnection(_Connection156))
            {
                sql = @$"  SELECT  DISTINCT ExecOpenLink , ExecDatabase FROM  [DB_SV_Data_Config].[dbo].[SYS_Hospital] A  WHERE  id ={hos_id}; ";
                hos = connection156.Query<SYS_Hospital>(sql).FirstOrDefault();
            }
            var fwq = "";
            if (hos.ExecOpenLink != "192.168.18.156")
            {
                fwq = "[192.168.18.156].";
            }
            sql = @$" insert into {fwq}[SV_DATA_CONFIG].[dbo].[DA_Disease](HospitalID,[HOSPITAL_DISEASE],[IS_FILTER])
                      select DISTINCT {hos_id} ,DISEASE_NAME ,0 from [{hos.ExecDatabase}].[dbo].[DIC_DIAG_GATHER] A
                      LEFT JOIN {fwq}[SV_DATA_CONFIG].[dbo].[DA_Disease] B ON A.DISEASE_NAME=B.HOSPITAL_DISEASE WHERE B.ID IS NULL;
            ";
            updatezt(id, hos_id, "插入标准诊断到诊断字典【累增】", sql.Replace("'", "''"));
            JX_zx(sql, hos_id, id, hos);

        }
        public void JX_DIC_DRUG_ATC(int id, int hos_id)
        {
            var sql = "";
            SYS_Hospital hos = new SYS_Hospital();
            using (DbConnection connection156 = new SqlConnection(_Connection156))
            {
                sql = @$"  SELECT  DISTINCT ExecOpenLink , ExecDatabase FROM  [DB_SV_Data_Config].[dbo].[SYS_Hospital] A  WHERE  id ={hos_id}; ";
                hos = connection156.Query<SYS_Hospital>(sql).FirstOrDefault();
            }
            var fwq = "";
            if (hos.ExecOpenLink != "192.168.18.156")
            {
                fwq = "[192.168.18.156].";
            }
            sql = @$" IF EXISTS(SELECT * FROM [{hos.ExecDatabase}].dbo.SYSOBJECTS WHERE NAME = 'DIC_DRUG_ATC')
			drop table [{hos.ExecDatabase}].[dbo].[DIC_DRUG_ATC];
			CREATE TABLE [dbo].[DIC_DRUG_ATC](
					[ID] [int] IDENTITY(1,1) NOT NULL,
					[ITEM_NAME] [nvarchar](200) NULL,
					[TYPE_NAME] [nvarchar](200) NULL,
					[I_ITEM_NAME] [nvarchar](200) NULL,
					[ATC_CODE] [nvarchar](50) NULL,
					[MEDIC_AREA] [nvarchar](200) NULL
					);
            SELECT * into dbo.DA_Hos_Category FROM {fwq}[DB_SV_Data_Config].[dbo].[DA_Hos_Category]
					INSERT INTO [dbo].[DIC_DRUG_ATC](
				    [ITEM_NAME],MEDIC_AREA,TYPE_NAME)
					SELECT DISTINCT ITEM_NAME,MEDIC_AREA,[Keyword]
					FROM [DBO].[OUT_FEE] A,[dbo].[DA_Hos_Category] C
					WHERE A.CATEGORY=C.CATEGORY AND C.insurance_category LIKE '%药%' and a.ITEM_NAME is not null
					UNION 
					SELECT DISTINCT ITEM_NAME,MEDIC_AREA,[Keyword]
					FROM [DBO].[INPAT_FEE] A,[dbo].[DA_Hos_Category] C
					WHERE A.CATEGORY=C.CATEGORY AND C.insurance_category LIKE '%药%' and a.ITEM_NAME is not null
					drop table DA_Hos_Category;
             SELECT * into dbo.DA_Drug FROM {fwq}[SV_DATA_CONFIG].[dbo].[DA_Drug]

			  update [dbo].[DIC_DRUG_ATC] 
			  set I_ITEM_NAME=b.CommonName,ATC_CODE=b.ATC
			  from [dbo].[DIC_DRUG_ATC] a,
			  {fwq}[SV_DATA_CONFIG].[dbo].[DA_Drug] b
			  where   b.CommonName is not null and b.DrugName=a.ITEM_NAME;
			  DROP TABLE DA_Drug";
            updatezt(id, hos_id, "创建诊断项目汇总表", sql.Replace("'", "''"));
            JX_zx(sql, hos_id, id, hos);


        }
        public void JX_ADD_DA_Drug(int id, int hos_id)
        {
            var sql = "";
            SYS_Hospital hos = new SYS_Hospital();
            using (DbConnection connection156 = new SqlConnection(_Connection156))
            {
                sql = @$"  SELECT  DISTINCT ExecOpenLink , ExecDatabase FROM  [DB_SV_Data_Config].[dbo].[SYS_Hospital] A  WHERE  id ={hos_id}; ";
                hos = connection156.Query<SYS_Hospital>(sql).FirstOrDefault();
            }
            var fwq = "";
            if (hos.ExecOpenLink != "192.168.18.156")
            {
                fwq = "[192.168.18.156].";
            }
            sql = @$" insert into {fwq}[SV_DATA_CONFIG].[dbo].[DA_Drug](HospitalID,[DrugName],[IsExec],[MEDIC_AREA],[ORIGINALDRUGTYPE])
	                   select DISTINCT {hos_id},ITEM_NAME,NULL,MEDIC_AREA,[TYPE_NAME] from (
	                   SELECT  distinct ITEM_NAME,a.MEDIC_AREA,[TYPE_NAME]
	                   FROM [dbo].[DIC_DRUG_ATC] a
	                   left join (select distinct drugname,medic_area from {fwq}[SV_DATA_CONFIG].[dbo].[DA_Drug] )  b on a.ITEM_NAME=b.DrugName and a.medic_area=b.medic_area
	                   where a.medic_area is  not null  and b.drugname is null 
	                   union 
	                   SELECT  distinct ITEM_NAME,a.MEDIC_AREA,[TYPE_NAME]
	                   FROM [dbo].[DIC_DRUG_ATC] a
	                   left join (select distinct drugname,medic_area from {fwq}[SV_DATA_CONFIG].[dbo].[DA_Drug] )  b on a.ITEM_NAME=b.DrugName
	                   where a.medic_area is  null and b.drugname is null ) m 
            ";
            updatezt(id, hos_id, "将未匹配到的药品插入到DA_Drug表中【累增】", sql.Replace("'", "''"));
            JX_zx(sql, hos_id, id, hos);

        }


        public void JX_DRUG_DATA_QZ(int id, int hos_id)
        {
            var sql = "";
            int num = 0;
            SYS_Hospital hos = new SYS_Hospital();
            using (DbConnection configConnection = new SqlConnection(_configConnectionString)) // DefaultConnection
            using (DbConnection connection156 = new SqlConnection(_Connection156))
            {
                sql = @$"  SELECT  DISTINCT ExecOpenLink , ExecDatabase FROM  [DB_SV_Data_Config].[dbo].[SYS_Hospital] A  WHERE  id ={hos_id}; ";
                hos = connection156.Query<SYS_Hospital>(sql).FirstOrDefault();
                sql = @$"   select count(1)from [SV_QueryPlatform].[dbo].[权重执行sql] where type ='药品' ";
                num = configConnection.Query<int>(sql).FirstOrDefault();
                int i = 1;
                updatezt(id, hos_id, "更新药品权重", sql.Replace("'", "''"));
                for (i = 1; i < num + 1; i++)
                {
                    sql = @$"  select execsql from [SV_QueryPlatform].[dbo].[权重执行sql] where type ='药品' and id={i} ";
                    string zxsql = configConnection.Query<string>(sql).FirstOrDefault();
                    connection156.Execute(sql, commandTimeout: 60 * 60 * 12);
                }
                sql = @$" update SV_DATA_CONFIG.[dbo].[DA_Drug] set ISEXEC = 0 where ISEXEC is null ;
	                      update SV_DATA_CONFIG.[dbo].[DA_Drug] set iscompletion = 0 where iscompletion is null";
                connection156.Query<int>(sql).FirstOrDefault();
            }

        }
        public void JX_DA_DIAGNOSIS_DATA(int id, int hos_id)
        {
            var sql = "";
            SYS_Hospital hos = new SYS_Hospital();
            DbConnection configConnection = new SqlConnection(_configConnectionString);
            DbConnection connection156 = new SqlConnection(_Connection156);
            sql = @$"  SELECT  DISTINCT ExecOpenLink , ExecDatabase FROM  [DB_SV_Data_Config].[dbo].[SYS_Hospital] A  WHERE  id ={hos_id}; ";
            hos = connection156.Query<SYS_Hospital>(sql).FirstOrDefault();
            sql = @$"  UPDATE [SV_DATA_CONFIG].[dbo].[DA_Disease] SET [FILTER_DISEASE] = HOSPITAL_DISEASE where IS_FILTER = 0 ;
	                   update [SV_DATA_CONFIG].[dbo].DA_DISEASE set FILTER_DISEASE = replace(FILTER_DISEASE,CHAR(13),'') where  IS_FILTER = 0 and CHARINDEX(CHAR(13),FILTER_DISEASE) > 0;
	                   update [SV_DATA_CONFIG].[dbo].DA_DISEASE set FILTER_DISEASE = replace(FILTER_DISEASE,CHAR(9),'') where IS_FILTER = 0 and  CHARINDEX(CHAR(19),FILTER_DISEASE) > 0;
	                   update [SV_DATA_CONFIG].[dbo].DA_DISEASE set FILTER_DISEASE = replace(FILTER_DISEASE,CHAR(10),'') where IS_FILTER = 0 and  CHARINDEX(CHAR(10),FILTER_DISEASE) > 0;";
            updatezt(id, hos_id, "剔除起始位 DA_Diagnosis_Data type=2的无效字符", sql.Replace("'", "''"));
            connection156.Execute(sql, commandTimeout: 60 * 60 * 12);

            sql = @$"  select ' update [SV_DATA_CONFIG].[dbo].DA_DISEASE 
          set FILTER_DISEASE = replace(FILTER_DISEASE,'''+[data]+''','''+[REPLACE]+''') 
		  where IS_FILTER = 0 and CHARINDEX('''+[data]+''',FILTER_DISEASE) > 0 ' from 特殊字符替换 ";
            string[] zxsqls = configConnection.Query<string>(sql).ToArray();
            foreach (var item in zxsqls)
            {
                connection156.Execute(item, commandTimeout: 60 * 60 * 12);
            }

            sql = @$"   update  [SV_DATA_CONFIG].[dbo].DA_DISEASE set FILTER_DISEASE = REPLACE( FILTER_DISEASE,substring(FILTER_DISEASE,
                        charindex('(',FILTER_DISEASE),charindex(')',FILTER_DISEASE) - charindex('(',FILTER_DISEASE) +1),'') 
                        where IS_FILTER = 0 and  charindex(')',FILTER_DISEASE) > 0 and charindex('(',FILTER_DISEASE) > 0  and charindex(')',FILTER_DISEASE) >  
                        charindex('(',FILTER_DISEASE) 
                        update  [SV_DATA_CONFIG].[dbo].DA_DISEASE set I_DEPARTMENT = t2.DEPARTMENT,I_CLASS_DISEASE = t2.DIAGNOSIS, 
                        I_ICD = t2.icd,I_DISEASE = t2.DISEASE,IS_EXEC =1 , EXEC_DATE = getdate(),REMARK ='ICD全文匹配' 
                        from SV_DATA_CONFIG.dbo.DA_DISEASE t1 join SV_DATA_CONFIG.dbo.DIC_ICD t2 
                        on t1.filter_disease = t2.DISEASE and t2.STATE = 1 where t1.IS_FILTER = 0;
                        update  [SV_DATA_CONFIG].[dbo].DA_DISEASE set I_DEPARTMENT = t2.DEPARTMENT,I_CLASS_DISEASE = t2.DIAGNOSIS, 
                        I_ICD = t2.icd,I_DISEASE = t2.DISEASE,IS_EXEC =1 , EXEC_DATE = getdate(),REMARK ='ICD全文匹配' 
                        from SV_DATA_CONFIG.dbo.DA_DISEASE t1 join SV_DATA_CONFIG.dbo.DIC_ICD t2 
                        on t1.HOSPITAL_DISEASE = t2.DISEASE and t2.STATE = 1 where t1.IS_FILTER = 0
                        UPDATE  [SV_DATA_CONFIG].[dbo].[DA_Disease] SET    IS_FILTER = 1 WHERE  IS_FILTER = 0
                   ";
            connection156.Execute(sql, commandTimeout: 60 * 60 * 12);
        }

        public void JX_DIAGNOSIS_DATA_QZ(int id, int hos_id)
        {
            var sql = "";
            SYS_Hospital hos = new SYS_Hospital();
            DbConnection configConnection = new SqlConnection(_configConnectionString);
            DbConnection connection156 = new SqlConnection(_Connection156.Replace("DB_SV_Data_Config", "SV_DATA_CONFIG"));
            sql = @$"  SELECT  DISTINCT ExecOpenLink , ExecDatabase FROM  [DB_SV_Data_Config].[dbo].[SYS_Hospital] A  WHERE  id ={hos_id}; ";
            hos = connection156.Query<SYS_Hospital>(sql).FirstOrDefault();
            sql = @$"   insert into da_disease_icd(disease_id,icd_id) select tab.disease_id,tab.icd_id from ( select id as disease_id,2450 as icd_id from dbo.da_disease where 1=1 and ( hospital_disease like '%高血压心脏病伴心力衰竭%'  and hospital_disease not like '%?%'   and hospital_disease not like '%待排%'  ) ) tab left join da_disease_icd t1 on t1.disease_id = tab.disease_id and t1.icd_id = tab.icd_id where t1.id is null
                          insert into da_disease_icd(disease_id,icd_id) select tab.disease_id,tab.icd_id from ( select id as disease_id,2454 as icd_id from dbo.da_disease where 1=1 and ( hospital_disease like '%高血压肾脏病不伴有肾衰竭%'  and hospital_disease not like '%?%'   and hospital_disease not like '%待排%'  ) ) tab left join da_disease_icd t1 on t1.disease_id = tab.disease_id and t1.icd_id = tab.icd_id where t1.id is null
                          insert into da_disease_icd(disease_id,icd_id) select tab.disease_id,tab.icd_id from ( select id as disease_id,2460 as icd_id from dbo.da_disease where 1=1 and ( hospital_disease like '%高血压（肾性）%'  and hospital_disease not like '%?%'   and hospital_disease not like '%待排%'  ) ) tab left join da_disease_icd t1 on t1.disease_id = tab.disease_id and t1.icd_id = tab.icd_id where t1.id is null
                          insert into da_disease_icd(disease_id,icd_id) select tab.disease_id,tab.icd_id from ( select id as disease_id,2471 as icd_id from dbo.da_disease where 1=1 and ( hospital_disease like '%继发性高血压%'  and hospital_disease not like '%?%'   and hospital_disease not like '%待排%'  ) ) tab left join da_disease_icd t1 on t1.disease_id = tab.disease_id and t1.icd_id = tab.icd_id where t1.id is null
                          insert into da_disease_icd(disease_id,icd_id) select tab.disease_id,tab.icd_id from ( select id as disease_id,2472 as icd_id from dbo.da_disease where 1=1 and ( hospital_disease like '%肾血管性高血压%'  and hospital_disease not like '%?%'   and hospital_disease not like '%待排%'  ) ) tab left join da_disease_icd t1 on t1.disease_id = tab.disease_id and t1.icd_id = tab.icd_id where t1.id is null
                          insert into da_disease_icd(disease_id,icd_id) select tab.disease_id,tab.icd_id from ( select id as disease_id,26069 as icd_id from dbo.da_disease where 1=1 and (hospital_disease='48 47急性冠周炎') ) tab left join da_disease_icd t1 on t1.disease_id = tab.disease_id and t1.icd_id = tab.icd_id where t1.id is null
                          insert into da_disease_icd(disease_id,icd_id) select tab.disease_id,tab.icd_id from ( select id as disease_id,33928 as icd_id from dbo.da_disease where 1=1 and ( hospital_disease like '%高血压（原发性）%'  ) ) tab left join da_disease_icd t1 on t1.disease_id = tab.disease_id and t1.icd_id = tab.icd_id where t1.id is null
                          insert into da_disease_icd(disease_id,icd_id) select tab.disease_id,tab.icd_id from ( select id as disease_id,33928 as icd_id from dbo.da_disease where 1=1 and ( hospital_disease like '%特发性（原发性）高血压%'  and hospital_disease not like '%?%'  ) ) tab left join da_disease_icd t1 on t1.disease_id = tab.disease_id and t1.icd_id = tab.icd_id where t1.id is null
                          insert into da_disease_icd(disease_id,icd_id) select tab.disease_id,tab.icd_id from ( select id as disease_id,33928 as icd_id from dbo.da_disease where 1=1 and ( hospital_disease like '%特发性高血压%'  ) ) tab left join da_disease_icd t1 on t1.disease_id = tab.disease_id and t1.icd_id = tab.icd_id where t1.id is null
                          insert into da_disease_icd(disease_id,icd_id) select tab.disease_id,tab.icd_id from ( select id as disease_id,33929 as icd_id from dbo.da_disease where 1=1 and ( hospital_disease like '%原发性高血压%'  and hospital_disease not like '%?%'  ) ) tab left join da_disease_icd t1 on t1.disease_id = tab.disease_id and t1.icd_id = tab.icd_id where t1.id is null
                          insert into da_disease_icd(disease_id,icd_id) select tab.disease_id,tab.icd_id from ( select id as disease_id,33930 as icd_id from dbo.da_disease where 1=1 and ( hospital_disease like '%高血压1级%'  and hospital_disease not like '%?%'  ) ) tab left join da_disease_icd t1 on t1.disease_id = tab.disease_id and t1.icd_id = tab.icd_id where t1.id is null
                          insert into da_disease_icd(disease_id,icd_id) select tab.disease_id,tab.icd_id from ( select id as disease_id,33930 as icd_id from dbo.da_disease where 1=1 and ( hospital_disease like '%高血压Ⅰ%'  and hospital_disease not like '%?%'  ) ) tab left join da_disease_icd t1 on t1.disease_id = tab.disease_id and t1.icd_id = tab.icd_id where t1.id is null
                          insert into da_disease_icd(disease_id,icd_id) select tab.disease_id,tab.icd_id from ( select id as disease_id,33931 as icd_id from dbo.da_disease where 1=1 and ( hospital_disease like '%高血压2%'  and hospital_disease not like '%?%'  ) ) tab left join da_disease_icd t1 on t1.disease_id = tab.disease_id and t1.icd_id = tab.icd_id where t1.id is null
                          insert into da_disease_icd(disease_id,icd_id) select tab.disease_id,tab.icd_id from ( select id as disease_id,33931 as icd_id from dbo.da_disease where 1=1 and ( hospital_disease like '%高血压Ⅱ%'  and hospital_disease not like '%?%'  ) ) tab left join da_disease_icd t1 on t1.disease_id = tab.disease_id and t1.icd_id = tab.icd_id where t1.id is null
                          insert into da_disease_icd(disease_id,icd_id) select tab.disease_id,tab.icd_id from ( select id as disease_id,33931 as icd_id from dbo.da_disease where 1=1 and ( hospital_disease like '%高血压3%'  and hospital_disease not like '%?%'   and hospital_disease not like '%待排%'  ) ) tab left join da_disease_icd t1 on t1.disease_id = tab.disease_id and t1.icd_id = tab.icd_id where t1.id is null
                          insert into da_disease_icd(disease_id,icd_id) select tab.disease_id,tab.icd_id from ( select id as disease_id,33933 as icd_id from dbo.da_disease where 1=1 and ( hospital_disease like '%高血压3%'  and hospital_disease not like '%?%'   and hospital_disease not like '%待排%'  ) ) tab left join da_disease_icd t1 on t1.disease_id = tab.disease_id and t1.icd_id = tab.icd_id where t1.id is null
                          insert into da_disease_icd(disease_id,icd_id) select tab.disease_id,tab.icd_id from ( select id as disease_id,33933 as icd_id from dbo.da_disease where 1=1 and ( hospital_disease like '%高血压Ⅲ%'  and hospital_disease not like '%?%'   and hospital_disease not like '%待排%'  ) ) tab left join da_disease_icd t1 on t1.disease_id = tab.disease_id and t1.icd_id = tab.icd_id where t1.id is null
                          insert into da_disease_icd(disease_id,icd_id) select tab.disease_id,tab.icd_id from ( select id as disease_id,33934 as icd_id from dbo.da_disease where 1=1 and ( hospital_disease like '%单纯收缩期高血压%'  and hospital_disease not like '%?%'   and hospital_disease not like '%待排%'  ) ) tab left join da_disease_icd t1 on t1.disease_id = tab.disease_id and t1.icd_id = tab.icd_id where t1.id is null
                          insert into da_disease_icd(disease_id,icd_id) select tab.disease_id,tab.icd_id from ( select id as disease_id,33935 as icd_id from dbo.da_disease where 1=1 and ( hospital_disease like '%高血压急症%'  and hospital_disease not like '%?%'   and hospital_disease not like '%待排%'  ) ) tab left join da_disease_icd t1 on t1.disease_id = tab.disease_id and t1.icd_id = tab.icd_id where t1.id is null
                          insert into da_disease_icd(disease_id,icd_id) select tab.disease_id,tab.icd_id from ( select id as disease_id,33936 as icd_id from dbo.da_disease where 1=1 and ( hospital_disease like '%难治性高血压%'  and hospital_disease not like '%?%'   and hospital_disease not like '%待排%'  ) ) tab left join da_disease_icd t1 on t1.disease_id = tab.disease_id and t1.icd_id = tab.icd_id where t1.id is null
                          insert into da_disease_icd(disease_id,icd_id) select tab.disease_id,tab.icd_id from ( select id as disease_id,33937 as icd_id from dbo.da_disease where 1=1 and ( hospital_disease like '%低肾素性高血压%'  and hospital_disease not like '%?%'   and hospital_disease not like '%待排%'  ) ) tab left join da_disease_icd t1 on t1.disease_id = tab.disease_id and t1.icd_id = tab.icd_id where t1.id is null
                          insert into da_disease_icd(disease_id,icd_id) select tab.disease_id,tab.icd_id from ( select id as disease_id,33938 as icd_id from dbo.da_disease where 1=1 and ( hospital_disease like '%高血压亚急症%'  and hospital_disease not like '%?%'   and hospital_disease not like '%待排%'  ) ) tab left join da_disease_icd t1 on t1.disease_id = tab.disease_id and t1.icd_id = tab.icd_id where t1.id is null
                          insert into da_disease_icd(disease_id,icd_id) select tab.disease_id,tab.icd_id from ( select id as disease_id,33940 as icd_id from dbo.da_disease where 1=1 and ( hospital_disease like '%肾萎缩伴有高血压%'  and hospital_disease not like '%?%'   and hospital_disease not like '%待排%'  ) ) tab left join da_disease_icd t1 on t1.disease_id = tab.disease_id and t1.icd_id = tab.icd_id where t1.id is null
                          insert into da_disease_icd(disease_id,icd_id) select tab.disease_id,tab.icd_id from ( select id as disease_id,33941 as icd_id from dbo.da_disease where 1=1 and ( hospital_disease like '%高血压心脏和肾脏病同时伴有(充血性)心力衰竭和肾衰竭%'  and hospital_disease not like '%?%'   and hospital_disease not like '%待排%'  ) ) tab left join da_disease_icd t1 on t1.disease_id = tab.disease_id and t1.icd_id = tab.icd_id where t1.id is null
                          insert into da_disease_icd(disease_id,icd_id) select tab.disease_id,tab.icd_id from ( select id as disease_id,33942 as icd_id from dbo.da_disease where 1=1 and ( hospital_disease like '%高血压心脏和肾脏病伴有(充血性)心力衰竭%'  and hospital_disease not like '%?%'   and hospital_disease not like '%待排%'  ) ) tab left join da_disease_icd t1 on t1.disease_id = tab.disease_id and t1.icd_id = tab.icd_id where t1.id is null
                          insert into da_disease_icd(disease_id,icd_id) select tab.disease_id,tab.icd_id from ( select id as disease_id,33943 as icd_id from dbo.da_disease where 1=1 and ( hospital_disease like '%高血压心脏病不伴有(充血性)心力衰竭%'  and hospital_disease not like '%?%'   and hospital_disease not like '%待排%'  ) ) tab left join da_disease_icd t1 on t1.disease_id = tab.disease_id and t1.icd_id = tab.icd_id where t1.id is null
                          insert into da_disease_icd(disease_id,icd_id) select tab.disease_id,tab.icd_id from ( select id as disease_id,33944 as icd_id from dbo.da_disease where 1=1 and ( hospital_disease like '%高血压性心力衰竭%'  and hospital_disease not like '%?%'   and hospital_disease not like '%待排%'  ) ) tab left join da_disease_icd t1 on t1.disease_id = tab.disease_id and t1.icd_id = tab.icd_id where t1.id is null
                          insert into da_disease_icd(disease_id,icd_id) select tab.disease_id,tab.icd_id from ( select id as disease_id,33946 as icd_id from dbo.da_disease where 1=1 and ( hospital_disease like '%高血压心脏病伴心力衰竭%'  and hospital_disease not like '%?%'   and hospital_disease not like '%待排%'  ) ) tab left join da_disease_icd t1 on t1.disease_id = tab.disease_id and t1.icd_id = tab.icd_id where t1.id is null
                          update da_disease set i_department='风湿科',i_class_disease='风湿热,未提及心脏受累',i_icd='I00.x01',i_disease='风湿性关节炎',is_exec=1,exec_date=getdate(),remark='后台人工处理' where 1=1 and filter_disease like '风湿性关节炎%'update da_disease set i_department='风湿科',i_class_disease='风湿热,未提及心脏受累',i_icd='I00.x01',i_disease='风湿性关节炎',is_exec=1,exec_date=getdate(),remark='后台人工处理' where 1=1 and filter_disease like '风湿性关节炎%' and is_exec is null 
                          update da_disease set i_department='风湿科',i_class_disease='风湿热,未提及心脏受累',i_icd='I00.x01',i_disease='风湿性关节炎',is_exec=1,exec_date=getdate(),remark='后台人工处理' where 1=1 and filter_disease like '关节炎%'update da_disease set i_department='风湿科',i_class_disease='风湿热,未提及心脏受累',i_icd='I00.x01',i_disease='风湿性关节炎',is_exec=1,exec_date=getdate(),remark='后台人工处理' where 1=1 and filter_disease like '关节炎%' and is_exec is null 
                          update da_disease set i_department='风湿科',i_class_disease='风湿热,未提及心脏受累',i_icd='I00.x01',i_disease='风湿性关节炎',is_exec=1,exec_date=getdate(),remark='后台人工处理' where 1=1 and filter_disease like '急性风湿性关节炎%'update da_disease set i_department='风湿科',i_class_disease='风湿热,未提及心脏受累',i_icd='I00.x01',i_disease='风湿性关节炎',is_exec=1,exec_date=getdate(),remark='后台人工处理' where 1=1 and filter_disease like '急性风湿性关节炎%' and is_exec is null 
                          update da_disease set i_department='风湿科',i_class_disease='脊椎关节强硬',i_icd='M47.822',i_disease='颈椎病',is_exec=1,exec_date=getdate(),remark='后台人工处理' where 1=1 and filter_disease like '颈椎病%'update da_disease set i_department='风湿科',i_class_disease='脊椎关节强硬',i_icd='M47.822',i_disease='颈椎病',is_exec=1,exec_date=getdate(),remark='后台人工处理' where 1=1 and filter_disease like '颈椎病%' and is_exec is null 
                          update da_disease set i_department='风湿科',i_class_disease='脊椎关节强硬',i_icd='M47.822',i_disease='颈椎病',is_exec=1,exec_date=getdate(),remark='后台人工处理' where 1=1 and hospital_disease like '颈椎病%'update da_disease set i_department='风湿科',i_class_disease='脊椎关节强硬',i_icd='M47.822',i_disease='颈椎病',is_exec=1,exec_date=getdate(),remark='后台人工处理' where 1=1 and hospital_disease like '颈椎病%' and is_exec is null 
                          update da_disease set i_department='风湿科',i_class_disease='其他脊椎病',i_icd='M48.921',i_disease='颈椎退行性病变',is_exec=1,exec_date=getdate(),remark='后台人工处理' where 1=1 and filter_disease like '颈椎退行性病变%'update da_disease set i_department='风湿科',i_class_disease='其他脊椎病',i_icd='M48.921',i_disease='颈椎退行性病变',is_exec=1,exec_date=getdate(),remark='后台人工处理' where 1=1 and filter_disease like '颈椎退行性病变%' and is_exec is null 
                          update da_disease set i_department='骨科',i_class_disease='其他椎间盘疾患',i_icd='M51.202',i_disease='腰椎间盘突出',is_exec=1,exec_date=getdate(),remark='后台人工处理' where 1=1 and filter_disease like '腰椎间盘突出%'update da_disease set i_department='骨科',i_class_disease='其他椎间盘疾患',i_icd='M51.202',i_disease='腰椎间盘突出',is_exec=1,exec_date=getdate(),remark='后台人工处理' where 1=1 and filter_disease like '腰椎间盘突出%' and is_exec is null 
                          update da_disease set i_department='骨科',i_class_disease='腰椎和骨盆关节和韧带脱位,扭伤和劳损',i_icd='S33.501',i_disease='腰部扭伤',is_exec=1,exec_date=getdate(),remark='后台人工处理' where 1=1 and filter_disease like '腰部扭伤%'update da_disease set i_department='骨科',i_class_disease='腰椎和骨盆关节和韧带脱位,扭伤和劳损',i_icd='S33.501',i_disease='腰部扭伤',is_exec=1,exec_date=getdate(),remark='后台人工处理' where 1=1 and filter_disease like '腰部扭伤%' and is_exec is null 
                          update da_disease set i_department='呼吸科',i_class_disease='肺炎,病原体未特指',i_icd='J18',i_disease='肺炎',is_exec=1,exec_date=getdate(),remark='后台人工处理' where 1=1 and  filter_disease like '右上肺炎%'update da_disease set i_department='呼吸科',i_class_disease='肺炎,病原体未特指',i_icd='J18',i_disease='肺炎',is_exec=1,exec_date=getdate(),remark='后台人工处理' where 1=1 and  filter_disease like '右上肺炎%' and is_exec is null 
                          update da_disease set i_department='呼吸科',i_class_disease='肺炎,病原体未特指',i_icd='J18',i_disease='肺炎',is_exec=1,exec_date=getdate(),remark='后台人工处理' where 1=1 and  filter_disease like '右下肺炎%'update da_disease set i_department='呼吸科',i_class_disease='肺炎,病原体未特指',i_icd='J18',i_disease='肺炎',is_exec=1,exec_date=getdate(),remark='后台人工处理' where 1=1 and  filter_disease like '右下肺炎%' and is_exec is null 
                          update da_disease set i_department='呼吸科',i_class_disease='肺炎,病原体未特指',i_icd='J18',i_disease='肺炎',is_exec=1,exec_date=getdate(),remark='后台人工处理' where 1=1 and  filter_disease like '左上肺炎%'update da_disease set i_department='呼吸科',i_class_disease='肺炎,病原体未特指',i_icd='J18',i_disease='肺炎',is_exec=1,exec_date=getdate(),remark='后台人工处理' where 1=1 and  filter_disease like '左上肺炎%' and is_exec is null 
                          update da_disease set i_department='呼吸科',i_class_disease='肺炎,病原体未特指',i_icd='J18',i_disease='肺炎',is_exec=1,exec_date=getdate(),remark='后台人工处理' where 1=1 and  filter_disease like '左下肺炎%' and is_exec is null
                          update da_disease set i_department='呼吸科',i_class_disease='肺炎,病原体未特指',i_icd='J18',i_disease='肺炎',is_exec=1,exec_date=getdate(),remark='后台人工处理' where 1=1 and  filter_disease like '左下肺炎%'update da_disease set i_department='呼吸科',i_class_disease='肺炎,病原体未特指',i_icd='J18',i_disease='肺炎',is_exec=1,exec_date=getdate(),remark='后台人工处理' where 1=1 and  filter_disease like '左下肺炎%' and is_exec is null 
                          update da_disease set i_department='呼吸科',i_class_disease='慢性阻塞性肺病',i_icd='J44.103',i_disease='慢性阻塞性肺病伴急性加重',is_exec=1,exec_date=getdate(),remark='后台人工处理' where 1=1 and filter_disease like 'AECOPD%'update da_disease set i_department='呼吸科',i_class_disease='慢性阻塞性肺病',i_icd='J44.103',i_disease='慢性阻塞性肺病伴急性加重',is_exec=1,exec_date=getdate(),remark='后台人工处理' where 1=1 and filter_disease like 'AECOPD%' and is_exec is null 
                          update da_disease set i_department='呼吸科',i_class_disease='慢性阻塞性肺病',i_icd='J44.901',i_disease='慢性阻塞性肺病',is_exec=1,exec_date=getdate(),remark='后台人工处理' where 1=1 and filter_disease like 'COPD%'update da_disease set i_department='呼吸科',i_class_disease='慢性阻塞性肺病',i_icd='J44.901',i_disease='慢性阻塞性肺病',is_exec=1,exec_date=getdate(),remark='后台人工处理' where 1=1 and filter_disease like 'COPD%' and is_exec is null 
                          update da_disease set i_department='口腔科',i_class_disease='龈炎和牙周疾病',i_icd='K05.203',i_disease='急性牙周炎',is_exec=1,exec_date=getdate(),remark='后台人工处理' where 1=1 and filter_disease like 'a牙周炎%'update da_disease set i_department='口腔科',i_class_disease='龈炎和牙周疾病',i_icd='K05.203',i_disease='急性牙周炎',is_exec=1,exec_date=getdate(),remark='后台人工处理' where 1=1 and filter_disease like 'a牙周炎%' and is_exec is null 
                          update da_disease set i_department='泌尿外科',i_class_disease='前列腺炎性疾病',i_icd='N41.001',i_disease='急性前列腺炎',is_exec=1,exec_date=getdate() where 1=1 and filter_disease like '急性前列腺炎%'  and is_exec is null
                          update da_disease set i_department='泌尿外科',i_class_disease='前列腺炎性疾病',i_icd='N41.101',i_disease='慢性前列腺炎',is_exec=1,exec_date=getdate() where 1=1 and filter_disease like '慢性前列腺炎%'  and is_exec is null
                          update da_disease set i_department='泌尿外科',i_class_disease='前列腺炎性疾病',i_icd='N41.901',i_disease='前列腺炎',is_exec=1,exec_date=getdate() where 1=1 and filter_disease like '前列腺炎%'  and is_exec is null
                          update da_disease set i_department='普外科',i_class_disease='结肠恶性肿瘤',i_icd='C18.2',i_disease='升结肠恶性肿瘤',is_exec=1,exec_date=getdate(),remark='后台人工处理' where 1=1 and hospital_disease like '%升结肠恶性肿瘤%'
                          update da_disease set i_department='普外科',i_class_disease='结肠恶性肿瘤',i_icd='C18.3',i_disease='结肠肝曲恶性肿瘤',is_exec=1,exec_date=getdate(),remark='后台人工处理' where 1=1 and hospital_disease like '%结肠肝曲恶性肿瘤%'
                          update da_disease set i_department='普外科',i_class_disease='结肠恶性肿瘤',i_icd='C18.4',i_disease='横结肠恶性肿瘤',is_exec=1,exec_date=getdate(),remark='后台人工处理' where 1=1 and hospital_disease like '%横结肠恶性肿瘤%'
                          update da_disease set i_department='普外科',i_class_disease='结肠恶性肿瘤',i_icd='C18.5',i_disease='结肠脾曲恶性肿瘤',is_exec=1,exec_date=getdate(),remark='后台人工处理' where 1=1 and hospital_disease like '%结肠脾曲恶性肿瘤%'
                          update da_disease set i_department='普外科',i_class_disease='结肠恶性肿瘤',i_icd='C18.6',i_disease='降结肠恶性肿瘤',is_exec=1,exec_date=getdate(),remark='后台人工处理' where 1=1 and hospital_disease like '%降结肠恶性肿瘤%'
                          update da_disease set i_department='消化科',i_class_disease='霍乱',i_icd='A00',i_disease='霍乱',is_exec=1,exec_date=getdate(),remark='后台人工处理' where 1=1 and filter_disease like '霍乱%' and filter_disease not like '%接触%' and filter_disease not like '%菌%' and filter_disease not like '%疫苗%'update da_disease set i_department='消化科',i_class_disease='霍乱',i_icd='A00',i_disease='霍乱',is_exec=1,exec_date=getdate(),remark='后台人工处理' where 1=1 and filter_disease like '霍乱%' and filter_disease not like '%接触%' and filter_disease not like '%菌%' and filter_disease not like '%疫苗%' and is_exec is null 
                          update da_disease set i_department='消化科',i_class_disease='胃溃疡',i_icd='K25',i_disease='胃溃疡',is_exec=1,exec_date=getdate(),remark='后台人工处理' where 1=1 and filter_disease like '胃溃疡%'update da_disease set i_department='消化科',i_class_disease='胃溃疡',i_icd='K25',i_disease='胃溃疡',is_exec=1,exec_date=getdate(),remark='后台人工处理' where 1=1 and filter_disease like '胃溃疡%' and is_exec is null 
                          update da_disease set i_department='消化科',i_class_disease='胃溃疡',i_icd='K25.301',i_disease='急性胃溃疡',is_exec=1,exec_date=getdate(),remark='后台人工处理' where 1=1 and filter_disease like '急性胃溃疡%'update da_disease set i_department='消化科',i_class_disease='胃溃疡',i_icd='K25.301',i_disease='急性胃溃疡',is_exec=1,exec_date=getdate(),remark='后台人工处理' where 1=1 and filter_disease like '急性胃溃疡%' and is_exec is null 
                          update da_disease set i_department='消化科',i_class_disease='胃溃疡',i_icd='K25.401',i_disease='胃溃疡伴出血',is_exec=1,exec_date=getdate(),remark='后台人工处理' where 1=1 and filter_disease like '胃溃疡伴出血%'update da_disease set i_department='消化科',i_class_disease='胃溃疡',i_icd='K25.401',i_disease='胃溃疡伴出血',is_exec=1,exec_date=getdate(),remark='后台人工处理' where 1=1 and filter_disease like '胃溃疡伴出血%' and is_exec is null 
                          update da_disease set i_department='消化科',i_class_disease='胃溃疡',i_icd='K25.501',i_disease='胃溃疡伴穿孔',is_exec=1,exec_date=getdate(),remark='后台人工处理' where 1=1 and filter_disease like '胃溃疡伴穿孔%'update da_disease set i_department='消化科',i_class_disease='胃溃疡',i_icd='K25.501',i_disease='胃溃疡伴穿孔',is_exec=1,exec_date=getdate(),remark='后台人工处理' where 1=1 and filter_disease like '胃溃疡伴穿孔%' and is_exec is null 
                          update da_disease set i_department='消化科',i_class_disease='胃溃疡',i_icd='K25.701',i_disease='慢性胃溃疡',is_exec=1,exec_date=getdate(),remark='后台人工处理' where 1=1 and filter_disease like '慢性胃溃疡%'update da_disease set i_department='消化科',i_class_disease='胃溃疡',i_icd='K25.701',i_disease='慢性胃溃疡',is_exec=1,exec_date=getdate(),remark='后台人工处理' where 1=1 and filter_disease like '慢性胃溃疡%' and is_exec is null 
                          update da_disease set i_department='消化科',i_class_disease='胃炎和十二指肠炎',i_icd='K29',i_disease='胃炎和十二指肠炎',is_exec=1,exec_date=getdate(),remark='后台人工处理' where 1=1 and hospital_disease like '胃炎%' and is_exec is null
                          update da_disease set i_department='心内科',i_class_disease='高血压病',i_icd='I10.x04',i_disease='高血压I期',is_exec=1,exec_date=getdate() where 1=1 and filter_disease like '高血压%'  and hospital_disease like '%高血压1%' and is_exec is null
                          update da_disease set i_department='心内科',i_class_disease='高血压病',i_icd='I10.x04',i_disease='高血压I期',is_exec=1,exec_date=getdate() where 1=1 and filter_disease like '高血压%'  and hospital_disease like '%高血压I%' and is_exec is null
                          update da_disease set i_department='心内科',i_class_disease='高血压病',i_icd='I10.x04',i_disease='高血压I期',is_exec=1,exec_date=getdate() where 1=1 and filter_disease like '高血压%' and hospital_disease like '%高血压1级%' and is_exec is null
                          update da_disease set i_department='心内科',i_class_disease='高血压病',i_icd='I10.x05',i_disease='高血压Ⅱ期',is_exec=1,exec_date=getdate() where 1=1 and filter_disease like '高血压%'  and hospital_disease like '%高血压3%' and is_exec is null
                          update da_disease set i_department='心内科',i_class_disease='高血压病',i_icd='I10.x05',i_disease='高血压Ⅱ期',is_exec=1,exec_date=getdate() where 1=1 and filter_disease like '高血压%'  and hospital_disease like '%高血压II%' and is_exec is null
                          update da_disease set i_department='心内科',i_class_disease='高血压病',i_icd='I10.x05',i_disease='高血压Ⅱ期',is_exec=1,exec_date=getdate() where 1=1 and filter_disease like '高血压%' and hospital_disease like '%高血压2级%' and is_exec is null
                          update da_disease set i_department='心内科',i_class_disease='高血压病',i_icd='I10.x06',i_disease='高血压Ⅲ期',is_exec=1,exec_date=getdate() where 1=1 and filter_disease like '高血压%' and hospital_disease like '%高血压3级%' and is_exec is null
                   ";
            connection156.Execute(sql, commandTimeout: 60 * 60 * 12);
            sql = $@"update SV_DATA_CONFIG.dbo.da_disease set i_department=t2.DEPARTMENT,i_class_disease=t2.DIAGNOSIS,i_icd=t2.ICD,i_disease=t2.DISEASE,is_exec=2,exec_date=getdate(),
                     REMARK = 'sql脚本执行'  FROM SV_DATA_CONFIG.dbo.DA_Disease T1 JOIN (select distinct DEPARTMENT,ICD,diagnosis,disease from SV_DATA_CONFIG.dbo.DIC_ICD where state = 1 ) T2 ON   
                     T1.filter_disease like '%'+t2.disease+'%' and t1.hospital_disease like '%'+t2.disease+'%' where  t1.is_exec is null ;
                     INSERT INTO SV_DATA_CONFIG.[dbo].[DA_DISEASE_ICD] (DISEASE_ID,ICD_ID)
			         SELECT A.ID,B.ID FROM SV_DATA_CONFIG.DBO.DA_Disease A
			         JOIN SV_DATA_CONFIG.DBO.DIC_ICD B ON A.I_ICD = B.ICD
			         WHERE  A.IS_EXEC = 2 AND A.I_ICD IS NOT NULL;
                     update SV_DATA_CONFIG.DBO.DA_Disease set is_exec = 1 where IS_EXEC = 2;
                     update SV_DATA_CONFIG.dbo.DA_Disease set IS_EXEC = 0 where IS_EXEC is null ;";
            connection156.Execute(sql, commandTimeout: 60 * 60 * 12);
        }
    }
}
