﻿using Dapper;
using Health.Api.Infrastructure.Modules;
using Microsoft.Data.SqlClient;
using System;
using System.Collections.Generic;
using System.Data.Common;
using System.Linq;

namespace Health.Api.Infrastructure.Queries
{

    public class DrugqueryQueries
    {
        private readonly string _Connection156;
        private readonly string _configConnectionString;
        //private List<Common> a;
        bool state = true;
        public DrugqueryQueries(string Connection156, string configConnectionString)
        {
            _Connection156 = Connection156;
            _configConnectionString = configConnectionString;
        }



        //查询所有医院
        public List<SYS_Hospital> showHospitals()
        {
            DbConnection connection156 = new SqlConnection(_Connection156);

            // sys_hospital156找医院
            var sql = @$"SELECT
                         ExecOpenLink ,
                         ExecDatabase
                      FROM  [DB_SV_Data_Config].[dbo].[SYS_Hospital]
                      WHERE ExecOpenLink <>'' AND ExecOpenLink IS NOT NULL 
                      AND ExecDatabase <>'' AND ExecDatabase IS NOT NULL 
                      ";
            return connection156.Query<SYS_Hospital>(sql).ToList();


        }

        /// <summary>
        /// 获取到最大的那条记录id
        /// </summary>
        /// <returns></returns>
        public int DrugqueryIndexs()
        {
            var indexs = "";
            using (DbConnection configConnection = new SqlConnection(_configConnectionString))
            {

                indexs = @$"SELECT  max(id) id FROM [SV_QueryPlatform].[dbo].[MEDIC_SEARCH_RECORD]";
                int a = configConnection.Query<int>(indexs).FirstOrDefault();
                return a;
            }
            return 0;
        }

        /// <summary>
        /// 获取到最大的那条记录Complete_MarkId
        /// </summary>
        /// <returns></returns>
        public int Complete_MarkId(int Indexs)
        {
            DbConnection configConnection = new SqlConnection(_configConnectionString);
            return configConnection.Query<int>(@$"select COMPLETE_MARK from  [SV_QueryPlatform].[dbo].[MEDIC_SEARCH_RECORD] where id={Indexs} ").FirstOrDefault();
        }

        /// <summary>
        ///传入sql 连接 返回int
        /// </summary>
        /// <returns></returns>
        public int Countnum(string sql, DbConnection configConnection)
        {
            int c = configConnection.Query<int>(sql).FirstOrDefault();
            return c;
        }

        /// <summary>
        /// 插入查询记录表
        /// </summary>
        /// <param name="sYS_Drugquery"></param>
        public int SqlAdd(SYS_Drugquery sYS_Drugquery, int type)
        {
            string peojectName = sYS_Drugquery.peojectName;
            string drugName = "";
            string diseaseName = "";
            string icd = "";
            string lx = "";

            if (type == 1)
            {
                lx = "疾病"; if (sYS_Drugquery.diseaseName != null) foreach (var item in sYS_Drugquery.diseaseName) { diseaseName = string.Join(",", sYS_Drugquery.diseaseName); }
                if (sYS_Drugquery.icd != null) foreach (var item in sYS_Drugquery.icd) { icd = string.Join(",", sYS_Drugquery.icd); }
            }
            else if (type == 2) { lx = "药品"; foreach (var item in sYS_Drugquery.drugName) { drugName = string.Join(",", sYS_Drugquery.drugName); } }
            else if (type == 3) { lx = "材料"; foreach (var item in sYS_Drugquery.materialName) { drugName = string.Join(",", sYS_Drugquery.materialName); } }
            DbConnection connection = new SqlConnection(_configConnectionString);
            var sql = @$"INSERT INTO [SV_QueryPlatform].[dbo].[MEDIC_SEARCH_RECORD]([HOS_TYPE],[PROJECT_NAME],[GENERIC_NAME],[COMMODITY_NAME],[DISEASE_NAME],[ICD],
                        [COMPLETE_MARK],[search_time],type ,[TYPE1_2] )
                        VALUES(0,'{peojectName}','{ drugName}',null,'{diseaseName}',
                        '{icd}',21,getdate(),'{lx}','{sYS_Drugquery.type1_2}')";
            connection.Execute(sql, commandTimeout: 60 * 60 * 5);

            sql = @$"select max(id) from  [SV_QueryPlatform].[dbo].[MEDIC_SEARCH_RECORD] 
                      where PROJECT_NAME='{peojectName}' and GENERIC_NAME='{drugName}' and DISEASE_NAME='{diseaseName}' 
                        and icd='{icd}' and type='{lx}' and  [TYPE1_2]='{sYS_Drugquery.type1_2}'";
            int num = connection.Query<int>(sql).FirstOrDefault();

            //添加一条查询记录 
            sql = $@"CREATE TABLE [SV_QueryPlatform_].[dbo].[MEDIC_PERSON_INFORMATION_{num}](
                         	[ID] [int] IDENTITY(1,1) NOT NULL,
                         	[HOS_ID] [int] NULL,
                         	[MASTER_INDEX] [int] NULL,
                         	[BIRTHDAY] [datetime2](7) NULL,
                         	[SEX] [nvarchar](50) NULL,
                         	[PERSON_CODE] [nvarchar](50) NULL,
                         	[PERSON_ID] [int] NULL,
                         	[REG_CODE] [nvarchar](50) NULL,
                         	[REG_ID] [int] NULL,
                         	[REG_SOURCE] [nvarchar](50) NULL,
                         	[REG_TIME] [datetime2](7) NULL,
                         	[AREA_ID] [int] NULL,
                         	[INDEXS] [int] NULL,
                         	[TYPE] [int] NULL,
                         	[DEPT_NAME] [nvarchar](50) NULL,
                         	[MEDIC_AREA] [nvarchar](max) NULL,
                  CONSTRAINT [PK_MEDIC_PERSON_INFORMATIONaa_{num}] PRIMARY KEY CLUSTERED 
                 (
                 	[ID] ASC
                 )WITH (PAD_INDEX = OFF, STATISTICS_NORECOMPUTE = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS = ON, ALLOW_PAGE_LOCKS = ON) ON [PRIMARY]
                 ) ON [PRIMARY] TEXTIMAGE_ON [PRIMARY]  ";
            connection.Execute(sql, commandTimeout: 60 * 60 * 5);

            sql = $@"CREATE TABLE [SV_QueryPlatform_].[dbo].[MEDIC_AREA_{num}](
                          	[ID] [int] IDENTITY(1,1) NOT NULL,
                          	[HOS_ID] [int] NULL,
                          	[ITEM_NAME] [nvarchar](500) NULL,
                          	[MEDIC_AREA] [nvarchar](50) NULL,
                          	[TYPE] [int] NULL,
                          	[INDEXS] [nvarchar](50) NULL,
                          	[MEDIC_NAME] [nvarchar](50) NULL
                          ) ON [PRIMARY]";
            connection.Execute(sql, commandTimeout: 60 * 60 * 5);

            return num;
        }



        /// <summary>
        /// 查询疾病对应的病人信息
        /// </summary>
        /// <param name="type">类型1</param>
        /// <param name="icd">ICD编码</param>
        /// <param name="diseaseName">疾病名称</param>
        /// <param name="type1_2">类型</param>
        public void Diseasequery(int type, int type1_2, string[] icd, string[] diseaseName, int Indexs)
        {
            var sql = "";
            int num = 0;
            int CompleteMar = 0;
            var icd_or_diseaseCondition = "";
            if (icd != null)
            {
                foreach (var icdname in icd)
                {
                    if (!string.IsNullOrEmpty(icdname))
                        icd_or_diseaseCondition = icd_or_diseaseCondition + $"or icd like '%{icdname}%'";
                }
            }

            if (diseaseName != null)
            {
                foreach (var disease in diseaseName)
                {
                    if (!string.IsNullOrEmpty(disease))
                        icd_or_diseaseCondition = icd_or_diseaseCondition + $"or DISEASE_NAME like '%{disease}%'";
                }
            }
            icd_or_diseaseCondition = icd_or_diseaseCondition.Substring(2, icd_or_diseaseCondition.Length - 2);

            DbConnection configConnection = new SqlConnection(_configConnectionString);

            List<SYS_Hospital> hos = configConnection.Query<SYS_Hospital>(@$"SELECT ExecOpenLink ,ExecDatabase FROM  [192.168.18.156].[DB_SV_Data_Config].[dbo].[SYS_Hospital] WHERE   ExecOpenLink <>'' AND ExecOpenLink IS NOT NULL AND ExecDatabase <>'' AND ExecDatabase IS NOT NULL ").ToList();

            服务器 fwq = new 服务器();
            var msConnectionString = "";
            var countsql = 0;
            foreach (var item in hos)
            {
                //统计执行的多少家医院
                countsql++;


                var fwqsql = $"SELECT  [服务器ip],[数据库账号],[数据库密码] FROM [SV_QueryPlatform].[dbo].[服务器] where [服务器ip] ='{item.ExecOpenLink}'";
                fwq = configConnection.Query<服务器>(fwqsql).FirstOrDefault();
                msConnectionString = string.Format("Server={0};Database={1};User ID={2};Password={3};Trusted_Connection=False;", item.ExecOpenLink, item.ExecDatabase, fwq.数据库账号, fwq.数据库密码);
                var sql2 = "";
                using (DbConnection conn = new SqlConnection(msConnectionString))
                {
                    //获取MEDIC_SEARCH_RECORD表的id和COMPLETE_MARK 
                    CompleteMar = Complete_MarkId(Indexs);
                    if (CompleteMar == 23)
                    {
                        throw new DomainException("查询失败！！");
                    }
                    if (CompleteMar == 31)
                    {
                        throw new DomainException("查询取消！！");
                    }
                    try
                    {
                        //判断状态 21在执行
                        if (CompleteMar == 21)
                        {
                            if (Countnum($@"SELECT count(*) FROM {item.ExecDatabase}.dbo.SYSOBJECTS WHERE NAME = 'DIC_DIAG_SUMMARY'", conn) > 0)
                            {
                                if (Countnum($@"SELECT count(*) a FROM {item.ExecDatabase}.[dbo].[DIC_DIAG_SUMMARY]  where {icd_or_diseaseCondition} ", conn) > 0)
                                {
                                    sql2 = $@" IF EXISTS(SELECT * FROM [{item.ExecDatabase}].dbo.SYSOBJECTS WHERE NAME = 'MEDIC_PERSON_INFORMATION_{Indexs}')
			                               drop  table [{item.ExecDatabase}].[dbo].MEDIC_PERSON_INFORMATION_{Indexs};
                  					     SELECT C.MASTER_INDEX,A.PERSON_CODE,A.PERSON_ID,A.REG_CODE,A.REG_ID,1 REG_SOURCE,A.REG_TIME, {Indexs}Indexs,a.org_Code hos_id,C.BIRTHDAY,C.SEX,1 TYPE,A.DEPT_NAME into [{item.ExecDatabase}].[dbo].MEDIC_PERSON_INFORMATION_{Indexs} FROM   
                                         {item.ExecDatabase}.[DBO].OUT_REG_INFO A ,
                  		                 (SELECT DISTINCT REG_ID FROM 
                                         {item.ExecDatabase}.[DBO].OUT_DIAG WHERE  {icd_or_diseaseCondition}) B,
                  				         {item.ExecDatabase}.[DBO].PUB_PATIENT C WHERE A.REG_ID=B.REG_ID AND   A.PERSON_ID=C.PERSON_ID
                  					     UNION ALL
                  					     SELECT C.MASTER_INDEX,A.PERSON_CODE,A.PERSON_ID,A.REG_CODE,A.REG_ID,2 REG_SOURCE,A.INHOS_TIME,{Indexs},a.org_Code hos_id,C.BIRTHDAY,C.SEX,1 TYPE,A.OUT_DEPT_NAME FROM 
                                         {item.ExecDatabase}.[DBO].INPAT_REG_INFO A , (SELECT DISTINCT REG_ID FROM  {item.ExecDatabase}.[DBO].INPAT_DIAG WHERE {icd_or_diseaseCondition}) B,
                  				         {item.ExecDatabase}.[DBO].PUB_PATIENT C
                  					     WHERE A.REG_ID=B.REG_ID AND   A.PERSON_ID=C.PERSON_ID";

                                    conn.Execute(sql2, commandTimeout: 60 * 60 * 5);

                                    sql2 = $@" insert into [SV_QueryPlatform_].[dbo].MEDIC_PERSON_INFORMATION_{Indexs } 
                                          ( [HOS_ID],[MASTER_INDEX],[BIRTHDAY],[SEX],[PERSON_CODE],[PERSON_ID],[REG_CODE],[REG_ID],[REG_SOURCE],
                                                 [REG_TIME], AREA_ID,[INDEXS],[TYPE],[DEPT_NAME] )
                                         SELECT [HOS_ID],[MASTER_INDEX],[BIRTHDAY],[SEX],[PERSON_CODE],[PERSON_ID],[REG_CODE],[REG_ID],[REG_SOURCE],
                                                 [REG_TIME],null AREA_ID,[INDEXS],[TYPE],[DEPT_NAME]  
                                         From [{item.ExecOpenLink}].[{item.ExecDatabase}].[dbo].MEDIC_PERSON_INFORMATION_{Indexs}";
                                    num = num + configConnection.Execute(sql2, commandTimeout: 60 * 60 * 5);
                                    //LOG($"查询成功，{num}行", $"{ITEM}", Indexs, "查询平台", "");

                                    if (type1_2 == 2)
                                    {
                                        sql2 = $@"IF EXISTS(SELECT * FROM [{item.ExecDatabase}].dbo.SYSOBJECTS WHERE NAME = 'MEDIC_PERSON_INFORMATION_{Indexs}_2')
			                                    drop  table [{item.ExecDatabase}].[dbo].MEDIC_PERSON_INFORMATION_{Indexs}_2;
                                                SELECT A.MASTER_INDEX,A.PERSON_CODE,A.PERSON_ID,B.REG_CODE,B.REG_ID,1 REG_SOURCE,B.REG_TIME,A.BIRTHDAY,A.SEX,2 TYPE, {Indexs} Indexs , b.org_code hos_id,B.DEPT_NAME  into [{item.ExecDatabase}].[dbo].MEDIC_PERSON_INFORMATION_{Indexs}_2
                                                FROM {item.ExecDatabase}.[DBO].PUB_PATIENT A, {item.ExecDatabase}.[DBO].OUT_REG_INFO B,
                                                (SELECT DISTINCT MASTER_INDEX FROM {item.ExecDatabase}.[DBO].[MEDIC_PERSON_INFORMATION_{Indexs}] WHERE INDEXS= {Indexs} AND HOS_ID =  cast(right('{item.ExecDatabase}',3)as int)) C  
                                                WHERE A.PERSON_ID=B.PERSON_ID AND  A.MASTER_INDEX=C.MASTER_INDEX  
                                                UNION ALL
                                                SELECT A.MASTER_INDEX,A.PERSON_CODE,A.PERSON_ID,B.REG_CODE,B.REG_ID,2 REG_SOURCE,B.INHOS_TIME,A.BIRTHDAY,A.SEX,2 TYPE,{Indexs} , b.org_code,B.OUT_DEPT_NAME
                                                FROM {item.ExecDatabase}.[DBO].PUB_PATIENT A, {item.ExecDatabase}.[DBO].INPAT_REG_INFO B,
                                                (SELECT DISTINCT MASTER_INDEX FROM {item.ExecDatabase}.[DBO].[MEDIC_PERSON_INFORMATION_{Indexs}] WHERE INDEXS={Indexs} AND HOS_ID =   cast(right('{item.ExecDatabase}',3)as int)) C
                                                WHERE A.PERSON_ID=B.PERSON_ID AND A.MASTER_INDEX=C.MASTER_INDEX ;";
                                        conn.Execute(sql2, commandTimeout: 60 * 60 * 5);
                                        sql2 = $@"INSERT INTO [SV_QueryPlatform_].[dbo].[MEDIC_PERSON_INFORMATION_{Indexs}]([HOS_ID],[MASTER_INDEX],[BIRTHDAY],[SEX],[PERSON_CODE],[PERSON_ID],[REG_CODE],[REG_ID],[REG_SOURCE],[REG_TIME],AREA_ID,[INDEXS],[TYPE],[DEPT_NAME])
                                                     select [HOS_ID],[MASTER_INDEX],[BIRTHDAY],[SEX],[PERSON_CODE],[PERSON_ID],[REG_CODE],[REG_ID],[REG_SOURCE],[REG_TIME],null,
                                                    [INDEXS],[TYPE],[DEPT_NAME] 
                                                     From [{item.ExecOpenLink}].[{item.ExecDatabase}].[dbo].MEDIC_PERSON_INFORMATION_{Indexs}_2";
                                        num = num + configConnection.Execute(sql2, commandTimeout: 60 * 60 * 5);
                                        sql2 = $@"  DELETE FROM M  FROM [SV_QueryPlatform_].[dbo].[MEDIC_PERSON_INFORMATION_{Indexs}] M  
                                                    INNER JOIN (SELECT * FROM [SV_QueryPlatform_].[dbo].[MEDIC_PERSON_INFORMATION_{Indexs}] WHERE INDEXS = {Indexs} 
                                                    AND HOS_ID =cast(right('{item.ExecDatabase}',3)as int) AND TYPE = 1) N  
                                                    ON M.INDEXS = N.INDEXS  AND M.HOS_ID = N.HOS_ID  AND M.MASTER_INDEX = N.MASTER_INDEX 
                                                    AND M.PERSON_ID = N.PERSON_ID AND M.REG_ID = N.REG_ID 
                                                    AND M.REG_SOURCE = N.REG_SOURCE    AND M.TYPE = 2 ;";
                                        num = num + configConnection.Execute(sql2, commandTimeout: 60 * 60 * 5);
                                        sql2 = $@" drop table [{item.ExecDatabase}].[dbo].MEDIC_PERSON_INFORMATION_{Indexs}_2;";
                                        num = num + conn.Execute(sql2, commandTimeout: 60 * 60 * 5);
                                        // LOG($"查询成功，{num}行", $"{ITEM}", Indexs, "查询平台", "");

                                    }
                                    sql2 = $@" drop table [{item.ExecDatabase}].[dbo].MEDIC_PERSON_INFORMATION_{Indexs}; ";
                                    num = num + conn.Execute(sql2, commandTimeout: 60 * 60 * 5);

                                }
                            }
                        }

                    }
                    catch (Exception e)
                    {
                        configConnection.Execute(@$"update [SV_QueryPlatform].[dbo].[MEDIC_SEARCH_RECORD] set COMPLETE_MARK = 23,END_TIME=getdate(),log='{sql2.Replace("'", "''")}' where  COMPLETE_MARK != 22 and id= " + Indexs);
                    }
                }

            }
            if (countsql == hos.Count)
            {
                configConnection.Execute("update [SV_QueryPlatform].[dbo].[MEDIC_SEARCH_RECORD] set COMPLETE_MARK = 22,END_TIME=getdate() where  COMPLETE_MARK != 22 and id= " + Indexs);

            }
            else
            {
                configConnection.Execute("update [SV_QueryPlatform].[dbo].[MEDIC_SEARCH_RECORD] set COMPLETE_MARK = 23,END_TIME=getdate() where  COMPLETE_MARK != 22 and id= " + Indexs);
            }



        }

        /// <summary>
        /// 查询药品信息
        /// </summary>
        /// <param name="type">类型2</param>
        /// <param name="type1_2">他因</param>
        /// <param name="drugName">药品名称</param>
        public void Drugquery(int type, int type1_2, string[] drugName , int Indexs)
        {
            var sql = "";
            int num = 0;
            int CompleteMar = 0; 
            var drugs = "";
            if (drugName != null)
            {
                foreach (var drug in drugName)
                {
                    if (!string.IsNullOrEmpty(drug))
                        drugs = drugs + $"or item_name like '%{drug}%'";
                }
            }

            drugs = drugs.Substring(2, drugs.Length - 2);

            DbConnection configConnection = new SqlConnection(_configConnectionString);

            List<SYS_Hospital> hos = configConnection.Query<SYS_Hospital>(@$"SELECT ExecOpenLink ,ExecDatabase FROM  [192.168.18.156].[DB_SV_Data_Config].[dbo].[SYS_Hospital] WHERE ExecOpenLink <>'' AND ExecOpenLink IS NOT NULL AND ExecDatabase <>'' AND ExecDatabase IS NOT NULL ").ToList();

            服务器 fwq = new 服务器();
            var msConnectionString = "";
            var countsql = 0;
            var sql2 = "";
            foreach (var item in hos)
            {
                //统计执行的多少家医院
                countsql++;
                var fwqsql = $"SELECT  [服务器ip],[数据库账号],[数据库密码] FROM [SV_QueryPlatform].[dbo].[服务器] where[服务器ip] ='{item.ExecOpenLink}'";
                fwq = configConnection.Query<服务器>(fwqsql).FirstOrDefault();
                msConnectionString = string.Format("Server={0};Database={1};User ID={2};Password={3};Trusted_Connection=False;", item.ExecOpenLink, item.ExecDatabase, fwq.数据库账号, fwq.数据库密码);

                using (DbConnection conn = new SqlConnection(msConnectionString))
                { 
                    CompleteMar = Complete_MarkId(Indexs);
                    if (CompleteMar == 23)
                    {
                        throw new DomainException("查询失败！！");
                    }
                    if (CompleteMar == 31)
                    {
                        throw new DomainException("查询停止！！");
                    }
                    try
                    { 
                        //判断状态 21在执行
                        if (CompleteMar == 21)
                        { 
                            if (Countnum($@"SELECT count(*) FROM {item.ExecDatabase}.dbo.SYSOBJECTS WHERE NAME = 'DIC_FEE_SUMMARY'", conn) > 0)
                            {
                                if (Countnum($@"SELECT count(*) a FROM {item.ExecDatabase}.[dbo].[DIC_FEE_SUMMARY]  where {drugs} ", conn) > 0)
                                {
                                    //药品信息查询语句
                                    foreach (var drug in drugName)
                                    {
                                        sql2 = $@"insert into [192.168.18.181].[SV_QueryPlatform_].[dbo].[MEDIC_AREA_{Indexs}] (
                                             [HOS_ID] ,[ITEM_NAME] ,[MEDIC_NAME],[MEDIC_AREA],[INDEXS] )
							      select  cast(right('{item.ExecDatabase}',3)as int) hos_id,ITEM_NAME, 
                                   '{drug}'MEDIC_NAME,medic_area medic_area,{Indexs} INDEXS  from {item.ExecDatabase}.[dbo].[DIC_FEE_SUMMARY] 
                                   WHERE  [ITEM_NAME] like '%{drug}%' GROUP BY ITEM_NAME,MEDIC_AREA ";
                                        conn.Execute(sql2, commandTimeout: 60 * 60 * 5);
                                    }

                                    if (Countnum($@"SELECT count(*) FROM [SV_QueryPlatform_].[dbo].[MEDIC_AREA_{Indexs}] 
                                                    where hos_id=cast(right('{item.ExecDatabase}',3)as int) and indexs={Indexs}", configConnection) > 0)
                                    {
                                        var sql3 = $@"IF EXISTS(SELECT * FROM [{item.ExecDatabase}].dbo.SYSOBJECTS WHERE NAME = 'MEDIC_PERSON_INFORMATION_{Indexs}')
			                               drop  table [{item.ExecDatabase}].[dbo].MEDIC_PERSON_INFORMATION_{Indexs};
                                     SELECT  C.MASTER_INDEX MASTER_INDEX,A.PERSON_CODE,A.PERSON_ID,A.REG_CODE,A.REG_ID,'1'REG_SOURCE,A.REG_TIME,B.ID AREA_ID, {Indexs} INDEXS,cast(right('{item.ExecDatabase}',3)as int) HOS_ID,C.BIRTHDAY,C.SEX,1 TYPE,A.DEPT_NAME into [{item.ExecDatabase}].[dbo].MEDIC_PERSON_INFORMATION_{Indexs}  FROM                                     
                                    {item.ExecDatabase}.[DBO].OUT_REG_INFO A, (SELECT DISTINCT REG_ID,D.ID FROM  {item.ExecDatabase}.[DBO].OUT_FEE E,
                                    (SELECT * FROM [192.168.18.181].[SV_QueryPlatform_].[dbo].[MEDIC_AREA_{Indexs}] WHERE INDEXS={Indexs} AND (MEDIC_AREA IS NULL OR MEDIC_AREA ='')) D  
                                    WHERE HOS_ID = cast(right('{item.ExecDatabase}',3)as int) AND E.ITEM_NAME=D.ITEM_NAME           
                                    UNION ALL          
                                    SELECT DISTINCT REG_ID,D.ID FROM {item.ExecDatabase}.[DBO].OUT_FEE E,          
                                    (SELECT * FROM [192.168.18.181].[SV_QueryPlatform_].[dbo].[MEDIC_AREA_{Indexs}] WHERE INDEXS= {Indexs} AND MEDIC_AREA IS NOT NULL AND MEDIC_AREA!='') D  
                                    WHERE HOS_ID =  cast(right('{item.ExecDatabase}',3)as int) AND E.ITEM_NAME=D.ITEM_NAME AND E.MEDIC_AREA=D.MEDIC_AREA          ) B,{item.ExecDatabase}.[DBO].PUB_PATIENT C      
                                    WHERE A.REG_ID=B.REG_ID        AND A.PERSON_ID=C.PERSON_ID       
                                    UNION ALL        
                                    SELECT C.MASTER_INDEX,A.PERSON_CODE,A.PERSON_ID,A.REG_CODE,A.REG_ID,2 REG_SOURCE,A.INHOS_TIME,B.ID,{Indexs} ,cast(right('{item.ExecDatabase}',3)as int),C.BIRTHDAY,C.SEX,1,A.OUT_DEPT_NAME FROM                                    
                                    {item.ExecDatabase}.[DBO].INPAT_REG_INFO A,        
                                    (SELECT DISTINCT REG_ID,D.ID FROM {item.ExecDatabase}.[DBO].INPAT_FEE E,          
                                    (SELECT * FROM [192.168.18.181].[SV_QueryPlatform_].[dbo].[MEDIC_AREA_{Indexs}] WHERE INDEXS= {Indexs} AND (MEDIC_AREA IS NULL OR MEDIC_AREA ='')) D  
                                    WHERE HOS_ID = cast(right('{item.ExecDatabase}',3)as int) AND E.ITEM_NAME=D.ITEM_NAME          
                                    UNION ALL          
                                    SELECT DISTINCT REG_ID,D.ID FROM [DBO].INPAT_FEE E,          
                                    (SELECT * FROM [192.168.18.181].[SV_QueryPlatform_].[dbo].[MEDIC_AREA_{Indexs}] WHERE INDEXS= {Indexs} AND MEDIC_AREA IS NOT NULL AND MEDIC_AREA!='') D  
                                    WHERE HOS_ID =  cast(right('{item.ExecDatabase}',3)as int)  AND E.ITEM_NAME=D.ITEM_NAME AND E.MEDIC_AREA=D.MEDIC_AREA) B, [DBO].PUB_PATIENT C   WHERE A.REG_ID=B.REG_ID  AND A.PERSON_ID=C.PERSON_ID";

                                        num = num + conn.Execute(sql3, commandTimeout: 60 * 60 * 5);
                                         
                                        sql2 = $@"insert into [SV_QueryPlatform_].[dbo].MEDIC_PERSON_INFORMATION_{Indexs}([HOS_ID],[MASTER_INDEX],[BIRTHDAY],[SEX],[PERSON_CODE],[PERSON_ID],[REG_CODE],[REG_ID],[REG_SOURCE],[REG_TIME],AREA_ID,[INDEXS],[TYPE],[DEPT_NAME])
                                                  SELECT [HOS_ID],[MASTER_INDEX],[BIRTHDAY],[SEX],[PERSON_CODE],[PERSON_ID],[REG_CODE],[REG_ID],[REG_SOURCE],[REG_TIME], AREA_ID,[INDEXS],[TYPE],[DEPT_NAME]  From [{item.ExecOpenLink}].[{item.ExecDatabase}].[dbo].MEDIC_PERSON_INFORMATION_{Indexs}";
                                        num = num + configConnection.Execute(sql2, commandTimeout: 60 * 60 * 5); 

                                    }
                                    if (type1_2 == 2)
                                    {
                                        sql2 = $@"IF EXISTS(SELECT * FROM [{item.ExecDatabase}].dbo.SYSOBJECTS WHERE NAME = 'MEDIC_PERSON_INFORMATION_{Indexs}_2')
			                                    drop  table [{item.ExecDatabase}].[dbo].MEDIC_PERSON_INFORMATION_{Indexs}_2;
                                                SELECT A.MASTER_INDEX,A.PERSON_CODE,A.PERSON_ID,B.REG_CODE,B.REG_ID,1 REG_SOURCE,B.REG_TIME,A.BIRTHDAY,A.SEX,2 TYPE, {Indexs} Indexs , b.org_code hos_id,B.DEPT_NAME  into [{item.ExecDatabase}].[dbo].MEDIC_PERSON_INFORMATION_{Indexs}_2
                                                FROM {item.ExecDatabase}.[DBO].PUB_PATIENT A, {item.ExecDatabase}.[DBO].OUT_REG_INFO B,
                                                (SELECT DISTINCT MASTER_INDEX FROM {item.ExecDatabase}.[DBO].[MEDIC_PERSON_INFORMATION_{Indexs}] WHERE INDEXS= {Indexs} AND HOS_ID =  cast(right('{item.ExecDatabase}',3)as int)) C  
                                                WHERE A.PERSON_ID=B.PERSON_ID AND  A.MASTER_INDEX=C.MASTER_INDEX
                                                UNION ALL
                                                SELECT A.MASTER_INDEX,A.PERSON_CODE,A.PERSON_ID,B.REG_CODE,B.REG_ID,2 REG_SOURCE,B.INHOS_TIME,A.BIRTHDAY,A.SEX,2 TYPE,{Indexs} , b.org_code,B.OUT_DEPT_NAME
                                                FROM {item.ExecDatabase}.[DBO].PUB_PATIENT A, {item.ExecDatabase}.[DBO].INPAT_REG_INFO B,
                                                (SELECT DISTINCT MASTER_INDEX FROM {item.ExecDatabase}.[DBO].[MEDIC_PERSON_INFORMATION_{Indexs}] WHERE INDEXS={Indexs} AND HOS_ID =   cast(right('{item.ExecDatabase}',3)as int)) C
                                                WHERE A.PERSON_ID=B.PERSON_ID AND A.MASTER_INDEX=C.MASTER_INDEX;";
                                        conn.Execute(sql2, commandTimeout: 60 * 60 * 5);
                                        sql2 = $@"INSERT INTO [SV_QueryPlatform_].[dbo].[MEDIC_PERSON_INFORMATION_{Indexs}]([HOS_ID],[MASTER_INDEX],[BIRTHDAY],[SEX],[PERSON_CODE],[PERSON_ID],[REG_CODE],[REG_ID],[REG_SOURCE],[REG_TIME],AREA_ID,[INDEXS],[TYPE],[DEPT_NAME])
                                                     select [HOS_ID],[MASTER_INDEX],[BIRTHDAY],[SEX],[PERSON_CODE],[PERSON_ID],[REG_CODE],[REG_ID],[REG_SOURCE],[REG_TIME],null,[INDEXS],[TYPE],[DEPT_NAME] From [{item.ExecOpenLink}].[{item.ExecDatabase}].[dbo].MEDIC_PERSON_INFORMATION_{Indexs}_2";
                                        num = num + configConnection.Execute(sql2, commandTimeout: 60 * 60 * 5);
                                        sql2 = $@"  DELETE FROM M  FROM [SV_QueryPlatform_].[dbo].[MEDIC_PERSON_INFORMATION_{Indexs}] M  
                                                    INNER JOIN (SELECT * FROM [SV_QueryPlatform_].[dbo].[MEDIC_PERSON_INFORMATION_{Indexs}] WHERE INDEXS = {Indexs} 
                                                    AND HOS_ID =cast(right('{item.ExecDatabase}',3)as int) AND TYPE = 1) N  
                                                    ON M.INDEXS = N.INDEXS  AND M.HOS_ID = N.HOS_ID  AND M.MASTER_INDEX = N.MASTER_INDEX 
                                                    AND M.PERSON_ID = N.PERSON_ID AND M.REG_ID = N.REG_ID 
                                                    AND M.REG_SOURCE = N.REG_SOURCE    AND M.TYPE = 2 ;";
                                        num = num + configConnection.Execute(sql2, commandTimeout: 60 * 60 * 5);
                                        sql2 = $@" drop table [{item.ExecDatabase}].[dbo].MEDIC_PERSON_INFORMATION_{Indexs}_2;";
                                        num = num + conn.Execute(sql2, commandTimeout: 60 * 60 * 5); 

                                    }
                                    sql2 = $@" drop table [{item.ExecDatabase}].[dbo].MEDIC_PERSON_INFORMATION_{Indexs}; ";
                                    num = num + conn.Execute(sql2, commandTimeout: 60 * 60 * 5);

                                }
                            }
                        }
                    }
                    catch (Exception e)
                    {
                        configConnection.Execute($"update [SV_QueryPlatform].[dbo].[MEDIC_SEARCH_RECORD] set COMPLETE_MARK = 23,END_TIME=getdate(),log='{ sql2.Replace("'", "''")}' where  COMPLETE_MARK != 22 and id= " + Indexs);
                    }
                }
            }
            //判断是否查完全部医院
            if (countsql == hos.Count)
            {
                configConnection.Execute("update [SV_QueryPlatform].[dbo].[MEDIC_SEARCH_RECORD] set COMPLETE_MARK = 22,END_TIME=getdate() where  COMPLETE_MARK != 22 and id= " + Indexs);

            }
            configConnection.Execute("update [SV_QueryPlatform].[dbo].[MEDIC_SEARCH_RECORD] set COMPLETE_MARK = 23,END_TIME=getdate() where  COMPLETE_MARK != 22 and id= " + Indexs);
        }
    }
}
